
;       LOCATE.COM   v1.17a   07-12-1996   C. Dye   raster@indirect.com
;
;       LOCATE.S is a source file for Eric Isaacson's excellent A86
;       assembler.  Assemble by typing:  A86 LOCATE.S
;
;       You may copy or distribute these files by whatever means.
;       If you wish to distribute a modified version, please include
;       my name and version number, as well as your name and a
;       summary of changes made.
;
;       I'm providing source in case anyone really wants (or needs) to
;       modify LOCATE.  It's big and ugly and messy; this utility has
;       grown by accretion.  So, don't view this as any example of
;       programming technique.
;
;       No warranty whatsoever.


radix 16

doscall macro                          ; call to dos int_21 with a
mov ah,#1                              ; one-byte function in ah
int 21
#em

doscall2 macro                         ; call to dos int_21 with a
mov ax,#1                              ; two-byte function in ax
int 21
#em

dosprint macro                         ; call to dos string-print function
mov dx,offset #1
mov ah,09
int 21
#em

zprint macro                           ; call to program's asciiz-print
mov di,offset #1                       ; subroutine
call zprint1
#em

country  equ  005c                     ; put country data in the psp
country_date equ country + 00
country_thou equ country + 07
country_deci equ country + 09
country_dsep equ country + 0b
country_tsep equ country + 0d
country_time equ country + 11


jmp begin                              ; skip over variables


tree_seg:                              ; segment for 64k tree buffer
dw 0000

tree_end:                              ; offset of second consecutive null
dw 0000

env_seg:                               ; segment of environment block
dw 0000

env_temp:                              ; used by path parse routine
dw 0000

lfn_seg:                               ; windows 95 only:
dw 0000                                ; segment for lfn buffer

find_what:                             ; 80 = only system or hidden
db 00                                  ; 40 = only files .COM .EXE .BAT
                                       ; 08 = search only in path
                                       ; 04 = don't search removable / remote

display:                               ; 00 peter, 01 summary, 02 batch
db 00                                  ; 03 macro string, 04 plain jane
                                       ; 05 old info, 06 naked, 07 sd-bare
                                       ; 08 long filenames with info

misc_flags:                            ; 80 = /g, go to directory
db 00                                  ; 40 = /g did go!  done went!  did it!
                                       ; 20 = /d /d+ or /d- specified by user
                                       ; 10 = no dupe_drives check
                                       ; 08 = peter, current dir printed?
                                       ; 04 = macro output, not batch
                                       ; 02 = user specified a directory
                                       ; 01 = parsing from environment

more_flags:                            ; 80 = don't chop lfn filenames
db 80                                  ; 40 = user specified drive(s)
                                       ; 08 = check date_1
                                       ; 04 = check date_2
                                       ; 02 = use next bit (12/24 flag)
                                       ; 01 = set: 24 hr clock, clear: 12 hr

attrib_care:                           ; which attributes must we match?
db 00                                  ; bit set = care, clear = don't care

attrib_value:                          ; values of the attributes we care
db 00                                  ; about

date_1:                                ; starting date of range to accept
dw 0000

date_2:                                ; ending date of range to accept
dw 0000

lines_max:                             ; lines to scroll before pausing:
db 00                                  ; 00 = no pauses

lines_count:                           ; used internally for scroll pauses
db 00

wide_count:                            ; used for /w listing
db 00
wide_max:
db 00

entry_count:                           ; number of files/directories found
dw 0000
entry_count_hi:
dw 0000

files_count:                           ; number of files found
dw 0000
files_count_hi:
dw 0000

dirs_count:                            ; number of directories found
dw 0000
dirs_count_hi:
dw 0000

hfiles_count:                          ; hidden/system files found:
dw 0000
hfiles_count_hi:
dw 0000

hdirs_count:                           ; hidden/system directories found:
dw 0000
hdirs_count_hi:
dw 0000

file_totals:                           ; total size of all files found
dw 0000
file_totals_hi:
dw 0000

max_count:                             ; maximum matches to report
dw 0000

drv1:                                  ; first drive to search
db 'A'

drv2:                                  ; last drive to search
db 'Z'

ddrv_table:                            ; bitmapped table of duplicate drives
db 04 dup 00

fn_buf:                                ; user's filespec goes here:
db 51 dup 00                           ; will finally hold just the dir name

fs_buf:                                ; filespec stripped from dir spec
db 0d dup 00

working:                               ; working filespec buffer
db 51 dup 00

bat_buf:                               ; stores the batch prefix
db 53 dup 00

bat_args:                              ; null if no %args needed, or
db 00                                  ; '1' to '9' for last %arg

working_end:
dw 0000

in_month:
dw 0000

in_day:
dw 0000

in_year:
dw 0000

in_word:
dw 0000

append_hack:                           ; used to hack around append, if
dw 0000                                ; present:

int_15_vec:                            ; original destination of int 15
dw 0000                                ; vector.  i hook int 15 to trap
int_15_vec_hi:                         ; control-break and control-c.
dw 0000

begin:
mov bl,80                              ; CHECK FOR A VALID VERSION OF DOS:
doscall2 3306                          ; dos true-version-number function
cmp bl,05
jb dos_old                             ; less than 5 is old
cmp bl,09
jb dos_okay                            ; 5 through 9 okay, 10+ is bad
dos_old:                               ; msdos is pre-5:
doscall2 3000                          ; do old-style dos version check
cmp al,03
ja dos_okay                            ; dos 4 or better is okay
jb dos_bad                             ; dos 2 or worse is NOT okay
cmp ah,14
jae dos_okay                           ; dos 3.20 or better is okay

dos_bad:
call append_restore
dosprint msg_dos_bad                   ; print error message
doscall2 4c05                          ; terminate program
doscall 00                             ; terminate if above failed (dos 1.x)

dos_okay:
mov bl,80
doscall2 3306                          ; dos true-version-number function
cmp bl,07                              ; dos 7.xx?
jne not_win_95                         ; if not, this is not windows 95
doscall2 3000                          ; get dos manufacturer id
cmp bh,0ff                             ; microsoft dos?
jne not_win_95                         ; if not, this is not windows 95
mov ax,1700
int 2f                                 ; is windows running?
cmp ax,1700
je not_win_95                          ; if not, this is not windows 95
inc w [lfn_seg]                        ; note that we are running under 95

not_win_95:
mov ax,0b700                           ; IS APPEND INSTALLED?
int 2f
cmp al,0ff
jne no_append                          ; no, skip ahead
mov ax,0b706                           ; yes, get append state
int 2f
test bx,0001                           ; is append enabled?
je no_append                           ; no, skip ahead
mov w [append_hack],bx                 ; yes, save append state
and bx,0fffe                           ; clear 'enabled' bit
mov ax,0b707                           ; set append state
int 2f
no_append:                             ; append is not a problem now

config_mem:                            ; CONFIGURE MEMORY:
mov sp,(end_of_code + 0400)            ; allow 1k of stack
push cs
pop es                                 ; get code segment into .es
mov bx,end_code_seg                    ; and new size in .bx
doscall 4a                             ; for dos resize memory-block function
jnc resize_ok                          ; if error,
call append_restore
dosprint msg_resize_error              ;    print error message
doscall2 4c04                          ;    and abort
resize_ok:
mov bx,1000
doscall 48                             ; request 64kb for tree buffer
jnc alloc_ok                           ; if any error,
call append_restore
dosprint msg_alloc_error               ;    print error message
doscall2 4c04                          ;    and abort
alloc_ok:
mov w [tree_seg],ax                    ; save segment for tree buffer
cmp w [lfn_seg],0000                   ; running under windows 95?
je got_lfn_buffer                      ; if not, don't allocate lfn buffer
mov bx,0021                            ; 528 bytes should be enough
doscall 48                             ; for the lfn buffer
jnc save_lfn_buffer                    ; if all is okay, continue
mov ax,0000                            ; if any problem, note no lfn buffer
save_lfn_buffer:
mov w [lfn_seg],ax
got_lfn_buffer:
mov dx,0080                            ; set dta to 0080h
doscall 1a                             ; (this is dos default)
mov dx,offset new_int24                ; grab the dos critical-error int.
doscall2 2524                          ; to disable 'abort-retry-fail' msg.
cmp b [0019],01                        ; is output redirected?
jne not_pausing                        ; if so, skip ahead
mov b [lines_max],16                   ; output is to screen, so set up for
mov b [lines_count],16                 ;    automatic scroll pausing:
and b [more_flags],7f                  ;    also enable lfn chopping
doscall2 3515
mov w [int_15_vec],bx                  ; get current int 15 handler's address
mov w [int_15_vec_hi],es               ; and save it
mov dx,offset new_int15
doscall2 2515                          ; hook int 15
not_pausing:

mov bl,01                              ; drive a:
doscall2 440e                          ; ioctl get-drive-map function
jc no_drv_b_fix                        ; if any error, skip this routine
cmp al,00                              ; only one floppy present in system?
je no_drv_b_fix                        ; if more than one, don't do b: fix
or b [ddrv_table],02                   ; don't search drive b:
mov bl,01                              ; drive a:
doscall2 440f                          ; map floppy as drive a:
no_drv_b_fix:
mov dx,offset country
doscall2 3800                          ; get current country info

call parse_env                         ; handle any locate= environment var.

mov di,offset fn_buf                   ; COPY FILENAME INTO BUFFER:
mov si,0081                            ; start at beginning of command tail
parse_fn:
lodsb                                  ; get a character
call force_uc                          ; convert lowercase to upper
call test_space                        ; is it a space?
je parse_fn_sp                         ; if so, go deal with it
cmp di,offset fn_buf
jne parse_fn_0                         ; if the first character
cmp al,'/'                             ; is a slash
je early_switch
cmp al,'-'                             ; or a dash,
jne parse_fn_0
early_switch:                          ; this is an 'early switch' :
mov w [fn_buf+0],'.' by '*'
mov w [fn_buf+2],00  by '*'            ; use default filespec of *.*
jmp parse_sw                           ; and skip ahead to the switch parser

parse_fn_0:
cmp al,'/'                             ; is it a slash?
jne parse_fn_1
mov al,'\'                             ; if so, convert to a backslash
parse_fn_1:
cmp al,'\'                             ; is it a slash or backslash?
jne parse_fn_2
or b [misc_flags],02                   ; if yes, note:  user specified dir.
parse_fn_2:
cmp al,':'
jne parse_fn_3
jmp parse_colon
parse_fn_3:
mov b [di],al                          ; stash character in buffer
inc di
cmp di,(fn_buf + 50)                   ; is the buffer full yet?
jb parse_fn                            ; nope, loop back for more
call append_restore
dosprint msg_buffer_full               ; yes, print error message
doscall2 4c02                          ;     and abort
parse_fn_sp:                           ; space or end-of-line found:
jc parse_fn_cr                         ; if it was a space
cmp b [fn_buf],00                      ;    and no filename found yet,
je parse_fn                            ;    ignore it and loop back
parse_fn_cr:                           ; end of line, or end of filename:
cmp b [fn_buf],00                      ; is there a filename in the buffer?
jne parse_fn_okay                      ; yes, continue
mov w [fn_buf+0],'.' by '*'
mov w [fn_buf+2],00  by '*'            ; no, use default filespec of *.*

parse_fn_okay:                         ; GOT A FILENAME IN THE BUFFER:
cmp al,0d                              ; at the end of the command line?
jne parse_sw                           ; no, parse any command-line switches
jmp parse_done                         ; yes, done parsing command line
parse_sw:                              ; look for switches :
lodsb                                  ; get a character
call test_switch                       ; return, space or switch char?
jnc parse_sw1
jmp parse_done                         ; if return, we are done parsing
parse_sw1:
je parse_sw                            ; space or switch, ignore it
call force_uc                          ; otherwise, force uppercase
mov di,0ffff
parse_sw2:
inc di                                 ; look at next char. in switch table
cmp b [switches+di],00                 ; is it a null?
je parse_syn                           ; if so, syntax error
cmp b [switches+di],al                 ; is it equal to the current char?
jne parse_sw2                          ; if not, keep looking
shl di,01
mov bx,w [switch_routines+di]          ; found it:  get the routine's address
jmp bx                                 ; and go there

parse_syn:
jmp syntax                             ; any other switch = syntax error

parse_colon:                           ; found a colon:
test b [more_flags],40                 ; drive already specified?
jne parse_colon_2                      ; if so, be cool about it
mov w [ddrv_table+0],0ffff
mov w [ddrv_table+2],0ffff             ; default to not searching any drives!
or b [more_flags],40                   ; note that drives have been specified
parse_colon_2:
cmp di,offset fn_buf                   ; is there anything before the colon?
jne parse_colon_3                      ; if so, deal with it
doscall 19                             ; if not, use current drive
call drive_bit1                        ; convert to bit pointer
xor ah,0ff                             ; invert bit mask
and b [ddrv_table+bx],ah               ; and permit this drive
jmp parse_colon_4
parse_colon_3:                         ; something before the colon:
dec di
mov al,b [di]                          ; get previous character
cmp al,'A'
jb parse_colon_bad                     ; was character a letter?
cmp al,'Z'                             ; if not, error
ja parse_colon_bad
call drive_bit                         ; convert drive letter to bit pointer
xor ah,0ff                             ; invert bit mask
and b [ddrv_table+bx],ah               ; and permit this drive
cmp di,offset fn_buf                   ; any characters before this one?
jne parse_colon_3                      ; if so, deal with them
parse_colon_4:                         ; done parsing drive letter(s):
mov b [di],00                          ; empty the filename buffer
jmp parse_fn                           ; get filename (or another drive!)

parse_colon_bad:                       ; drive letter wasn't a letter:
call append_restore
dosprint msg_bad_drv                   ; print an error message
doscall2 4c02                          ; and abort
ret

switch_t:
or b [find_what],08                    ; /t = set path flag
jmp skip_word                          ; and skip any nonswitch characters

switch_x:
or b [find_what],40                    ; /x = set exe flag
jmp skip_word                          ; and skip any nonswitch characters

switch_r:
or b [find_what],04                    ; /r = set no removable/remote flag
jmp skip_word                          ; and skip any nonswitch characters

switch_h:
or b [find_what],80                    ; /h = find only system and hidden
jmp skip_word                          ; skip any nonswitch characters

switch_m:
or b [misc_flags],10                   ; /m = skip test for duplicate drives
jmp skip_word                          ; skip any nonswitch characters

switch_d:                              ; /d = include directories, or not
and b [attrib_care],0ef                ; default:  include directories
test b [misc_flags],01                 ; parsing from environment?
jne switch_d1                          ; if not,
or b [misc_flags],20                   ;    note /d spec'ed on command line
switch_d1:
call next_char                         ; look at character after the D:
cmp al,'+'
je parse_sw_dp                         ; plus, show directories only
cmp al,'-'
je parse_sw_dm                         ; minus, show files only
jmp skip_word                          ; otherwise, don't care
parse_sw_dp:                           ; /d+
or b [attrib_care],10
or b [attrib_value],10                 ; display directories only
inc si
jmp switch_done
parse_sw_dm:                           ; /d-
or b [attrib_care],10
and b [attrib_value],0ef               ; never display directories
inc si
jmp switch_done

switch_g:                              ; /g = go to directory
or b [misc_flags],80                   ; set flag
call next_char                         ; look at next char
cmp al,':'                             ; is it a colon?
je switch_f                            ; if so, treat like a /f argument
cmp al,'-'                             ; is it a minus?
je switch_f                            ; if so, treat like a /f argument
call test_digit                        ; is it a digit?
je switch_f                            ; if so, treat like a /f argument
jmp skip_word                          ; otherwise, continue parsing normally

switch_f:
mov w [max_count],0000                 ; /f = max count of files to find
call next_char                         ; look at character after 'f'
cmp al,':'
jne parse_sw_f1                        ; if it is not a colon, no problem
inc si                                 ; if it is, just skip over it
parse_sw_f1:
call next_char                         ; get next character:
cmp al,'-'                             ; is it a minus?
je parse_sw_fy                         ; if so, exit without zero check
call test_digit                        ; is it a digit?
jne parse_sw_fx                        ; if not, exit /f parser
call parse_word                        ; get the number after /f
jc parse_sw_fz                         ; if overflow, error
mov w [max_count],ax                   ; if not, save new max_count value
parse_sw_fx:
cmp w [max_count],0000                 ; do we have a number?
jne parse_sw_fy                        ; if so, exit happily
inc w [max_count]                      ; if not, assume /f1
parse_sw_fy:    
jmp switch_done                        ; done with /f parser
parse_sw_fz:                           ; /f number too damn big:
call append_restore
dosprint msg_fz                        ; complain
doscall2 4c10                          ; and exit

switch_p:                              ; /p = peter display
switch_a:                              ; /a = peter display
mov b [display],00                     ; set for peter mode
mov b [wide_count],00                  ; not wide
jmp skip_word                          ; and skip any nonswitch characters

switch_w:                              ; /w = wide peter display
mov b [display],00                     ; set for peter mode
mov b [wide_count],05                  ; five columns wide
jmp skip_word                          ; and skip any nonswitch characters

switch_two:                            ; /2 = two-column display
call next_char
cmp al,'4'                             ; unless the next character is '4'!
je switch_twenty_four
mov b [display],00                     ; set for peter mode
mov b [wide_count],02                  ; two columns wide
jmp skip_word                          ; and skip any nonswitch characters

switch_twenty_four:                    ; /24 = force 24-hour display
or b [more_flags],03
inc si
jmp skip_word

switch_one:                            ; /1 = undefined!
call next_char
cmp al,'2'                             ; unless the next character is '2',
je switch_twelve                       ; /1 is always a syntax error
jmp syntax

switch_twelve:                         ; /12 = force 12-hour display
or b [more_flags],02
and b [more_flags],0fe
inc si
jmp skip_word

switch_s:                              ; /s = summary only
mov b [display],01
jmp skip_word

switch_b_nada:                         ; /b specified, with no prefix:
mov b [bat_buf],00                     ; empty the batch prefix buffer
dec si                                 ; undo that last lodsb
jmp skip_word                          ; and carry on with parse

switch_b:                              ; /b:"prefix"
and b [misc_flags],0fb                 ; note that this is /b, not /o
switch_b_o:                            ; parser for /b and /o:
mov b [bat_buf],00                     ; empty the batch prefix buffer
mov b [bat_args],00                    ; no batch arguments yet
mov bx,0000                            ; no characters in batch buffer
switch_b1:                             ; scan for first quote mark:
call next_char                         ; get the next character
call test_switch
jc switch_b_nada                       ; if carriage return, abort
je switch_b_nada                       ; if switch, abort
inc si
cmp al,'?'
je switch_b_bad                        ; /b? or /o? is a syntax request
cmp al,'0'
je switch_b1b                          ; 0 means no %args wanted
call test_digit                        ; any other digit?
jne switch_b1a                         
mov b [bat_args],al                    ; if so, store it
jmp switch_b1
switch_b1b:
mov b [bat_args],00                    ; 0, store null
jmp switch_b1
switch_b1a:
cmp al,'"'                             ; found the first quote yet?
jne switch_b1                          ; if not, loop back
switch_b2:                             ; found the first quote:
call next_char                         ; get the next character
cmp al,0d                              ; is it return?
je switch_b_bad                        ; if so, bad string, so abort
inc si
cmp al,'"'                             ; is it the second quote?
je switch_b3                           ; if so, deal with that
mov b [bat_buf+bx],al                  ; otherwise, stash the character
inc bx                                 ; and increment the buffer pointer
cmp bx,0051                            ; batch buffer overflow yet?
jne switch_b2                          ; if not, loop back for another char.
call append_restore
dosprint msg_bat_ovf                   ; batch buffer overflow:  complain
doscall2 4c10                          ; and abort
switch_b3:                             ; found the second quote:
cmp b [bat_buf],00                     ; something's in the buffer, right?
je switch_b_x                          ; if not, just leave the buffer empty
test b [misc_flags],04                 ; is this a /o string?
jne switch_b4                          ; if so, skip over space check
mov al,b [bat_buf-1+bx]                ; look at the last character in buffer
cmp al,20                              ; was the last character a space?
je switch_b4                           ; if so, don't add a final space
cmp al,09                              ; was the last character a tab?
je switch_b4                           ; if so, don't add a final space
mov b [bat_buf+bx],20                  ; otherwise ...
inc bx                                 ; add a final space
switch_b4:
mov w [bat_buf+bx],0001                ; always terminate with an 01,00
mov b [display],02                     ; display mode is 02 for batch
test b [misc_flags],04
je switch_b_x
mov b [display],03                     ; or 03 for macro output
switch_b_x:
jmp skip_word

switch_b_bad:                          ; bad syntax after /b or /o:
call append_restore                    ; prepare for error message
test b [misc_flags],04                 ; was it /b or /o?
jne switch_o_bad
dosprint msg_bad_bat                   ; print /b error message
doscall2 4c10                          ; and exit
switch_o_bad:
dosprint msg_bad_format                ; print /o error message
doscall2 4c10                          ; and exit

switch_o:                              ; /o:"format"
or b [misc_flags],04                   ; note that this is /o, not /b
jmp switch_b_o                         ; and use the /b parser

switch_j:                              ; /j = plain jane display
mov b [display],04
jmp skip_word                          ; skip any nonswitch characters

switch_i:                              ; /i = display additional info
mov b [display],05
jmp skip_word                          ; skip any nonswitch characters

switch_n:                              ; /n = bare naked / file list
mov b [display],06
jmp skip_word                          ; skip any nonswitch characters

switch_l:                              ; /l = windows 95 long filenames
cmp w [lfn_seg],0000                   ; running under win95?
je switch_lx                           ; if not, ignore this switch
mov b [display],08                     ; note display type
call next_char
cmp al,'+'
je switch_lp
cmp al,'-'
je switch_lm
switch_lx:
jmp skip_word                          ; skip any nonswitch characters
switch_lp:                             ; /l+  =  enable lfn chopping
and b [more_flags],7f
inc si
jmp switch_done
switch_lm:                             ; /l-  =  disable lfn chopping
or b [more_flags],80
inc si
jmp switch_done

switch_buck:                           ; /$ = single-drive bare mode
mov b [display],07
jmp skip_word                          ; skip any nonswitch characters

switch_c:                              ; /c = check attributes:
call next_char                         ; look at next character after /c
cmp al,':'                             ; is it a colon?
jne switch_c00                         ; if not, okay
inc si                                 ; if it is, just skip over it
switch_c00:
mov cl,00                              ; start with no attribute bits
switch_c0:
call next_char                         ; look at the next character
cmp al,'-'                             ; if it's a minus,
je switch_c_minus                      ;    attribute must be cleared
cmp al,'+'                             ; if it's a plus,
je switch_c_plus                       ;    attribute must be set
call test_switch                       ; if it's a switch,
je switch_c_exit                       ; done with this routine
call force_uc
mov di,0004
switch_c1:
cmp al,b [attr1+di]                    ; is it an attribute letter?  adshr
je switch_c_attr                       ; if so, deal with it
dec di
cmp di,0ffff
jne switch_c1                          ; otherwise, fall through to ....

switch_c_bad:                          ; bad syntax after /c:
call append_restore                    ; prepare for error message
dosprint msg_bad_chk                   ; print /c error message
doscall2 4c10                          ; and exit

switch_c_exit:                         ; done parsing /c string:
jmp parse_sw                           ; continue parsing switches

switch_c_attr:                         ; attribute letter:
or cl,b [attr_v+di]                    ; set the appropriate bit in .cl
inc si
jmp switch_c0                          ; and loop back to parse next char.

switch_c_minus:                        ; attribute bit(s) must be clear:
cmp cl,00                              ; were any attributes specified?
je switch_c_bad                        ;    if not, problem
or b [attrib_care],cl                  ; note that we care about this bit
xor cl,0ff
and b [attrib_value],cl                ; and that it must be clear
inc si                                 ; ahead to the next character
jmp switch_c00

switch_c_plus:                         ; attribute bit(s) must be set:
cmp cl,00                              ; were any attributes specified?
je switch_c_bad                        ;    if not, problem
or b [attrib_care],cl                  ; note that we care about this bit
or b [attrib_value],cl                 ; and that it must be clear
inc si                                 ; ahead to the next character
jmp switch_c00

switch_usa:                            ; /us = force united states output
mov b [country_date],00                ; u.s. date format
mov b [country_thou],','               ; comma thousands separator
mov b [country_deci],'.'               ; period decimal point
mov b [country_dsep],'-'               ; minus date separator
mov b [country_tsep],':'               ; colon time separator
mov b [country_time],00                ; twelve-hour clock
inc si
jmp skip_word

switch_u:                              ; /u = check update stamp:
call next_char                         ; look at next character
call force_uc
cmp al,'S'                             ; is it an s?
je switch_usa                          ; if so, force united states output
cmp al,':'                             ; is it a colon?
jne switch_u1
inc si                                 ; if so, skip over it
switch_u1:
call next_char                         ; look at next character
call force_uc
cmp al,'!'                             ; is it a '!' ?
je switch_ut                           ; if so, treat like /ut
cmp al,'T'                             ; is it a 't' ?
jne switch_u2                          ; if not, continue normally
switch_ut:
doscall 2a                             ; /ut:  get current date
sub cx,01980xd                         ; convert year to directory format
shl cx,09                              ; in top 7 bits
mov w [date_1],cx                      ; and save it
or b [date_1+0],dl                     ; plug in the day
mov dl,00
shr dx,03                              ; month in bits 5 through 8
or w [date_1],dx                       ; plug in the month
switch_ut_x:
mov ax,w [date_1]                      ; move date_1
mov w [date_2],ax                      ; into date_2
or b [more_flags],0c                   ; both are significant
jmp skip_word

switch_u_nada:                         ; /u with no dates specified:
and b [more_flags],0f3                 ; flag date_1 and date_2 unspecified
jmp switch_done                        ; and exit

switch_u2:                             ; not /ut:
call next_char                         ; look at the next character:
cmp al,','                             ; is it a comma?
je switch_u_d2                         ; if so, read in date2
cmp al,';'                             ; is it a semicolon?
je switch_u_d2                         ; if so, read in date2

call test_switch                       ; is it a switch?
je switch_u_nada                       ; if so, exit
call test_digit                        ; is it a digit?
jne switch_u_bad                       ; if not, abort
call parse_date                        ; date1 was specified:  read it in
jc switch_u_bad                        ; if any problems, abort
mov w [date_1],ax                      ; otherwise, save date1
or b [more_flags],08                   ; and flag date1 as significant

call next_char                         ; look at the next character:
cmp al,','                             ; is it a comma?
je switch_u_d2                         ; if so, read in date2
cmp al,';'                             ; is it a semicolon?
je switch_u_d2                         ; if so, read in date2
cmp al,'!'                             ; exclamation point?
je switch_ut_x                         ; if so, move date1 to date2 and exit.
jmp switch_u_x                         ; otherwise, exit /u

switch_u_d2:                           ; date2 was specified:
inc si                                 ; skip over comma or semicolon
call next_char                         ; and look at following character:
call test_digit                        ; is it a digit?
jne switch_u_bad                       ; if not, abort
call parse_date                        ; read in date2
jc switch_u_bad                        ; if any problems, abort
mov w [date_2],ax                      ; otherwise, save date2
or b [more_flags],04                   ; and flag date2 as significant

switch_u_x:                            ; done parsing /u:
jmp switch_done

switch_u_bad:                          ; any error in /u:
call append_restore                    ; prepare to print error message
dosprint msg_bad_ud                    ; print error message
call show_date_format                  ; and describe the current date format
doscall2 4c10                          ; and exit with errorlevel 16

parse_date:                            ; read in date:
call parse_word                        ; get the first number
jc parse_date_bad                      ; and abort if any problem with it
mov w [in_month],ax                    ; store it in the 'month' variable
call next_char                         ; look at the next character
call test_dsep                         ; is it a date separator?
jne parse_date_bad                     ; if not, abort
inc si                                 ; skip over the date separator
call parse_word                        ; and read in the second number
jc parse_date_bad                      ; abort if any problem with it
mov w [in_day],ax                      ; store it in the 'day' variable
call next_char                         ; look at the next character
call test_dsep                         ; is it a date separator?
je parse_date_05                       ; if so, continue normally
doscall 2a                             ; if not, get current date from dos
mov w [in_year],cx                     ; and use current year
cmp b [country_date],01                ; european date format?
je parse_date_eur                      ; if so, adjust it
jmp parse_date_combine                 ; us or japan format, leave it alone.

parse_date_bad:                        ; any error whilst reading in date:
stc                                    ; exit with carry set
ret

parse_date_05:                         ; a third number (year) was specified:
inc si                                 ; skip over the date separator
call parse_word                        ; and read in the third number
jc parse_date_bad                      ; abort if any problem with it
mov w [in_year],ax                     ; store it in the year variable

parse_date_world:                      ; internat'l: rearrange date if needed
mov al,b [country_date]                ; check date format
cmp al,00                              ; u.s. format?  mm-dd-yyyy
je parse_date_combine                  ; if so, leave date alone
cmp al,01                              ; european format?  dd-mm-yyyy
je parse_date_eur                      ; if so, fix it
mov ax,w [in_day]                      ; japanese format:  yyyy-mm-dd
mov bx,w [in_month]
mov cx,w [in_year]
mov w [in_month],ax                    ; move 'day' value into 'month'
mov w [in_day],cx                      ; move 'year' value into 'day'
mov w [in_year],bx                     ; move 'month' value into 'year'
jmp parse_date_combine
parse_date_eur:                        ; european format:  dd-mm-yyyy
mov ax,w [in_day]
mov bx,w [in_month]
mov w [in_day],bx                      ; move 'month' value into 'day'
mov w [in_month],ax                    ; move 'day' value into 'month'

parse_date_combine:                    ; combine date vars into a single word
mov ax,w [in_day]                      ; get 'day' variable
cmp ax,0000
je parse_date_bad                      ; zero or above 31 is bad
cmp ax,001f
ja parse_date_bad
mov bx,w [in_month]                    ; get 'month' variable
cmp bx,0000
je parse_date_bad                      ; zero or above 12 is bad
cmp bx,000c
ja parse_date_bad
shl bx,05                              ; multiply months by 32
or ax,bx                               ; and add to date
mov bx,w [in_year]                     ; get 'year' variable
cmp bx,080xd                           ; year 00 through 79?
jae parse_date_10
add bx,020xd                           ; add 20 (year 2000 through 2079)
jmp parse_date_20
parse_date_10:
cmp bx,0100xd                          ; year 80 through 99?
jae parse_date_15
sub bx,080xd                           ; subtract 80 (year 1980 through 1999)
jmp parse_date_20
parse_date_15:
sub bx,01980xd                         ; otherwise, subtract 1980
cmp bx,007f                            ; to get dos year 0 - 127
ja parse_date_bad                      ; anything bigger than 127 is an error
parse_date_20:
shl bx,09                              ; multiply dos year by 512
or ax,bx                               ; and add to date
clc
ret                                    ; done parsing year

parse_word:                            ; read in a decimal number:
mov w [in_word],0000
call next_char                         ; look at next character
call test_digit                        ; is it a digit?
jne parse_word_bad                     ; if so, error
parse_word_1:
inc si
sub al,'0'                             ; convert digit to
mov ah,00                              ; a 16-bit value
push ax                                ; and save it
mov ax,000a
mul w [in_word]                        ; multiply old value by ten
cmp dx,0000                            ; any overflow?
jne parse_word_bad                     ; if so, error
mov w [in_word],ax
pop ax
add w [in_word],ax                     ; add in the latest digit
jc parse_word_bad                      ; overflow?  if so, error
call next_char                         ; move on to next character:
call test_digit                        ; is it also a digit?
je parse_word_1                        ; if so, keep parsing
mov ax,w [in_word]                     ; if not, done parsing number
clc                                    ; return number in .ax with no carry
ret
parse_word_bad:                        ; any error:
stc                                    ; exit with carry set
ret

next_char:                             ; look ahead at next char to parse:
test b [misc_flags],01
jne next_char_e
mov al,b [si]                          ; get next character from command line
ret
next_char_e:
mov al,b [es:si]                       ; or next character from environment
ret

skip_word:                             ; valid switch:  skip remaining chars
test b [misc_flags],01
jne skip_env_word
lodsb                                  ; get a character
call test_switch                       ; return, switch, space?
jc parse_done                          ; return = done parsing
jne skip_word                          ; non-switch, non-space = lose it
jmp parse_sw                           ; otherwise, loop back for next switch
skip_env_word:
jmp parse_env_2

switch_done:
test b [misc_flags],01
jne skip_env_word
jmp parse_sw

parse_done:                            ; DONE READING IN COMMAND LINE:

dots_fix:                              ; FIX FOR FILESPEC OF JUST '.' OR '..'
mov si,offset fn_buf
mov bl,'\'
call find_last                         ; look for backslashes in filespec:
mov bx,offset fn_buf                   ; if none, look at start of fn_buf
je dots_fix_0
mov bx,ax
inc bx                                 ; if found, look just after the last
dots_fix_0:
cmp b [bx],'.'                         ; does the filespec start with '.' ?
jne dots_fix_x                         ; if not, never mind
cmp b [bx+1],00
jne dots_fix_1                         ; filespec of just . ?
mov w [bx+1],00 by '\'                 ; if so, change to .\
or b [misc_flags],02                   ; note:  user specified dir.
jmp dots_fix_x
dots_fix_1:
cmp w [bx+1],00 by '.'
jne dots_fix_x                         ; filespec of just .. ?
mov w [bx+2],00 by '\'                 ; if so, change to ..\
or b [misc_flags],02                   ; note:  user specified dir.
dots_fix_x:

mov si,offset fn_buf                   ; LOOK FOR DIRECTORY SPEC:
call find_last_bs                      ; find the last \ within filename buf.
jne dir_spec                           ; if found, skip ahead
mov si,offset fn_buf
mov di,offset fs_buf                   ; no directory was specified:
no_dir_spec_1:
mov al,b [si]                          ; copy filename
mov b [di],al                          ; into filespec buffer
inc si
inc di
cmp al,00
je no_dir_spec_2
cmp di,offset fs_buf + 0d              ; filespec longer than 12 chars?
jb no_dir_spec_1                       ; no, continue copying
call append_restore
dosprint msg_buffer_full               ; yes, print an error message
doscall2 4c02                          ; and abort
no_dir_spec_2:                         ; done copying filename:
mov w [fn_buf],00 by '\'               ; use default directory of '\'
jmp dir_spec_x                         ; and exit

dir_spec:                              ; A DIRECTORY WAS SPECIFIED:
mov dx,ax                              ; save offset of last '\'
mov si,ax
inc si                                 ; look at character after last '\':
cmp b [si],00                          ; is there any filespec?
jne dir_spec_1                         ; yes, skip ahead
mov w [fs_buf+0],'.' by '*'            ; directory specified, no filespec:
mov w [fs_buf+2],00 by '*'             ; use default of *.*
jmp dir_spec_x
dir_spec_1:                            ; directory and filespec both spec'ed:
mov di,offset fs_buf
dir_spec_2:
mov al,b [si]                          ; copy filename
mov b [di],al                          ; into filespec buffer
inc si
inc di
cmp al,00
je dir_spec_3
cmp di,offset fs_buf + 0d              ; filespec longer than 12 chars?
jb dir_spec_2                          ; no, continue copying
call append_restore
dosprint msg_buffer_full               ; yes, print an error message
doscall2 4c02                          ; and abort
dir_spec_3:                            ; done copying filename:
push dx
pop si
inc si                                 ; change character after last '\'
mov b [si],00                          ; to a null

dir_spec_x:                            ; CHECK DIR SPEC FOR WILDCARDS:
mov bl,'?'                             ; is there a question mark
mov si,offset fn_buf                   ;    in the directory name buffer?
call find_first
jne dir_spec_wc                        ; if so, error
mov bl,'*'                             ; is there an asterisk
mov si,offset fn_buf                   ;    in the directory name buffer?
call find_first
je dir_spec_xx                         ; if not, no wildcards, all is okay
dir_spec_wc:                           ; wildcard in directory name:
call append_restore
dosprint msg_dir_wc                    ;    print error message
doscall2 4c02                          ;    and abort

dir_spec_xx:                           ; DONE MESSING WITH DIRECTORY SPEC:
mov bl,'.'
mov si,offset fs_buf                   ; look for '.' in filespec
call find_first
jne dot_found_1
mov si,offset fs_buf                   ; there is no period:
call find_null                         ; find the terminal null
cmp si,(offset fs_buf + 8)             ; is it more than 8 characters after
jbe dot_not_found_1                    ;    the start of the filespec?
mov si,(offset fs_buf + 8)             ; if so, move it back
dot_not_found_1:
mov w [si],'*' by '.'                  ; dot was not found, add '.*'
inc si
inc si
mov b [si],00                          ; and terminal null to filespec
jmp dot_found_x
dot_found_1:                           ; there is a period:
cmp si,(offset fs_buf + 8)             ; is it more than 8 characters after
jbe dot_found_2                        ;    the start of the filespec?
mov di,(offset fs_buf + 8)
call copy_si_di_z                      ; if so, move the dot and ext. down
dot_found_2:
mov bl,'.'
mov si,offset fs_buf                   ; find the dot's position (again)
call find_first
add si,0004                            ; add 4
mov b [si],00                          ; poke in a null (ext. 3 chars max)
test b [find_what],40                  ; was /X specified?
je dot_found_x
sub si,0003                            ; if so, extension is always .*
mov w [si],00 by '*'                   ; so poke it in

dot_found_x:                           ; DONE MESSING WITH FILESPEC EXTENSION
mov si,offset fs_buf                   ; find the first asterisk in filespec
wc_fix:
mov bl,'*'
call find_first
je wc_fix_x                            ; no asterisk, skip ahead
inc si                                 ; look at first character after *
cmp b [si],00                          ; is it a null?
je wc_fix_x                            ;    yes, all is well
cmp b [si],'.'                         ; is it a period?
je wc_fix_p                            ;    yes, this is legal too
call append_restore
dosprint msg_wc_fix                    ; anything else is illegal --
doscall2 4c02                          ; print an error message and abort
wc_fix_p:                              ; asterisk before period:
inc si                                 ; move ahead to extension
jmp wc_fix                             ; and keep looking for asterisks
wc_fix_x:

                                       ; DONE MESSING WITH FILESPEC WILDCARDS
test b [misc_flags],02                 ; was a directory name specified?
je drv_fix_x                           ; if not, skip drive fix
test b [more_flags],40                 ; was a drive specified?
jne drv_fix_x                          ; if so, skip drive fix
doscall 19                             ; directory was spec'd, but no drive:
add al,'A'                             ; use current drive
mov b [drv1],al                        ;    for first drive
mov b [drv2],al                        ;    and last drive
drv_fix_x:

buck_fix:                              ; was /$ specified?
cmp b [display],07
jne buck_fix_x                         ; if not, never mind
test b [more_flags],40                 ; was a drive specified?
jne buck_fix_x                         ; if so, never mind
doscall 19                             ; /$ specified, no particular drive:
add al,'A'                             ; use current drive
mov b [drv1],al                        ;    for first drive
mov b [drv2],al                        ;    and last drive
buck_fix_x:                            ; done with /$ fix

test b [more_flags],40                 ; if only one drive to search,
je reconcile1        
and b [find_what],0fb                  ;    disregard any /R
reconcile1:
test b [misc_flags],80                 ; if /G specified
je reconcile2
cmp w [max_count],0000                 ; and /F not specified,
jne reconcile2
call error_output                      ;    force output to screen
mov b [wide_count],00                  ;    don't permit wide-Peter display
cmp b [display],01
jne reconcile2
mov b [display],00                     ;    or summary-only mode
reconcile2:
cmp b [display],02                     ; if display mode is batch
jb reconcile3
cmp b [display],03                     ; or macro output,
ja reconcile3
cmp b [bat_buf],00                     ; and the batch buffer is empty,
jne reconcile3
mov b [display],00                     ;    do a peter-style display instead.
reconcile3:
test b [find_what],40                  ; if /x was specified,
je reconcile4
or b [attrib_care],10                  ;    only find files
and b [attrib_value],0ef               ;    like /d-
reconcile4:
test b [more_flags],40                 ; if no drive specified,
jne reconcile6
doscall 19
cmp al,02                              ; and current drive is c: or higher,
jb reconcile6
mov b [drv1],'C'                       ;    start search at c: instead of a:
reconcile6:
cmp b [display],02                     ; if display mode is batch
jne reconcile7
test b [misc_flags],20                 ;     and user didn't specify /d,
jne reconcile7
or b [attrib_care],10
and b [attrib_value],0ef               ;     find files only (like /d-)
reconcile7:
mov al,b [more_flags]
and al,0c                              ; if date_1 and date_2 both specified,
cmp al,0c
jne reconcile8
mov ax,w [date_1]
cmp ax,w [date_2]
jbe reconcile8                         ;     and date_1 greater than date_2,
mov bx,w [date_2]
mov w [date_2],ax                      ;     swap them!
mov w [date_1],bx
reconcile8:
test b [more_flags],02                 ; if /12 or /24 was specified,
je reconcile9
mov al,b [more_flags]                  ;     set country_time appropriately
and al,01
mov b [country_time],al
reconcile9:
mov al,b [wide_count]                  ; remember the original value
mov b [wide_max],al                    ; of wide_count, to restore later

                                       ; DONE WITH POST-PARSE:
call dupe_drives                       ; check for duplicate drive mappings
cmp b [display],02                     ; in batch mode?
jne alls_well_2
zprint msg_bat_begin                   ; if so, print the '@echo off' message
alls_well_2:
mov bl,b [display]
mov bh,00
mov ch,b [num_blank_lines+bx]
cmp ch,00
je start_locate
zprint msg_null                        ; output a blank line
cmp ch,01
je start_locate
call zprint_add


start_locate:                          ; ABOUT TO START TREE CONSTRUCTION:
test b [find_what],08                  ; was /t specified?
je start_loc_0                         ; if not, continue
jmp use_path                           ; if so, we use an entirely different
start_loc_0:                           ;    routine to construct the tree
mov al,b [drv1]                        ; get current drive letter
call drive_bit                         ; and convert to bit address
test b [ddrv_table+bx],ah              ; is this drive excluded?
jne start_loc_not                      ; if so, don't use it.  duh.
test b [find_what],04                  ; was /r specified?
je start_loc_2                         ; if not, skip the following tests:
mov bl,b [drv1]                        ; get current drive
sub bl,40                              ; and convert to a 1-based number
doscall2 4408                          ; ioctl:  is drive removable?
jnc start_loc_1                        ; if call fails, skip this drive
start_loc_not:
jmp next_drive
start_loc_1:                           ; ioctl call succeeded:
test al,01                             ; is drive removable?
je start_loc_not                       ; if so, skip this drive
mov bl,b [drv1]                        ; get current drive
sub bl,40                              ; and convert to a 1-based number
doscall2 4409                          ; ioctl:  is drive remote?
jc start_loc_not                       ; if call fails, skip this drive
test dh,90                             ; is drive remote or subst'ed?
jne start_loc_not                      ; if so, skip this drive
start_loc_2:                           ; drive passes /r test, if needed:
mov dl,b [drv1]                        ; get current drive
sub dl,40                              ; and convert to a 1-based number
doscall 36                             ; dos:  get disk free space
cmp ax,0ffff                           ; is this a valid drive?
je start_loc_not                       ; if not, skip this drive

mov di,0000
mov es,w [tree_seg]                    ; start of tree buffer:
mov al,b [drv1]                        ; poke in drive letter
mov ah,':'                             ; and a colon
mov w [es:di],ax
add di,0002
mov si,offset fn_buf                   ; then copy in user's directory spec
call copy_si_esdi_z                    ; (normally just a backslash, null)
mov b [es:di],00                       ; finish up with a second null
mov w [tree_end],di                    ; and save offset of 2nd null

main_loop:                             ; MAIN LOCATE LOOP:
mov di,offset working
mov es,w [tree_seg]
mov si,0000                            ; copy the first directory in tree
call copy_essi_di_z                    ; buffer to the working buffer
dec di
mov w [working_end],di                 ; save the offset of dirname's null
mov si,offset star_dot_star            ; add a filespec of *.*
call copy_si_di_z                      ; to the directory name
and b [misc_flags],0f7                 ; current directory not yet displayed
mov dx,offset working
mov cx,0016                            ; include hidden, system, subdirs
doscall 4e                             ; in dos find-first-match function
jnc found_something                    ; did dos find a match?
jmp next_dir                           ; no, use the next dir in tree buffer
found_something:                       ; yes, dos found a match:
cmp b [009e],'.'                       ; was it the stupid . or .. entry?
je next_file                           ; if so, ignore it
mov si,009e                            ; copy the filename
mov di,w [working_end]                 ; into the working buffer
call copy_si_di_z                      ; right after the directory name:
test b [0095],10                       ; is the item a subdirectory?
je add_tree_not                        ; if not, don't add it to tree buffer
test b [find_what],08                  ; are we searching %path% only?
jne add_tree_not                       ; if so, don't add it to tree buffer
mov di,w [tree_end]                    ; ADD THIS DIRECTORY TO TREE BUFFER:
mov si,offset working                  ; copy the working buffer
call copy_si_esdi_z                    ; to the end of the tree buffer
dec di
mov w [es:di],00 by '\'                ; then add a backslash
add di,0002
mov b [es:di],00                       ; and a double-null
mov ax,di                              ;    new code to watch tree_end:
cmp ax,w [tree_end]                    ;    has pointer overflowed?
jae add_tree_20                        ;    if not, continue
jmp err_tree_ov                        ;    if so, barf and die
add_tree_20:
mov w [tree_end],di                    ; save offset of the second null
add_tree_not:
call test_filename                     ; print filename if it matches spec.
next_file:                             ; look for next file in this directory
cmp b [0019],01                        ;    was output redirected?
jne next_file1                         ;    if so, skip keyboard check
mov ah,01
int 16                                 ;    was a key pressed?
je next_file1                          ;    if not, do look for next file
mov b [lines_max],16                   ;    key was hit:  enable scroll-
mov b [lines_count],16                 ;    pausing (it might be off)
call pause                             ;    and pause for user keystrokes
next_file1:                            ; look for next file in this directory
doscall 4f                             ; dos find-next function
jc next_dir                            ; if no more matches, do next dir
jmp found_something                    ; if another match, loop back, do it
next_dir:
call peter_line_fix                    ; do line feeds as needed
mov si,0000                            ; start at beginning of tree buffer
call find_es_null                      ; and look for the first null
inc ax                                 ; is the character after it
cmp ax,w [tree_end]                    ; the final, tree-ending null?
je next_drive                          ; if so, skip ahead, do next drive
mov si,ax                              ; if not, more directories in tree buf
mov di,0000                            ; so copy entire tree buffer down
call copy_essi_esdi_zz                 ; to overwrite first directory in it
mov w [tree_end],di                    ; save new end-of-tree pointer
jmp main_loop                          ; and loop back to do new 1st dir.
next_drive:                            ; THE TREE BUFFER HAS BEEN EXHAUSTED:
test b [find_what],08                  ; is this is /t path search?
jne final_exit                         ; if so, exit program now
mov al,b [drv1]
cmp al,b [drv2]                        ; is this the final drive?
je final_exit                          ; if so, exit program
inc al                                 ; increment drive letter
mov b [drv1],al                        ; save new drive letter
jmp start_locate                       ; loop back, start a new tree

final_exit_1go:
jmp final_exit_1

final_exit:                            ; DONE SEARCHING FOR FILES:
mov ax,w [entry_count]
or ax,w [entry_count_hi]
cmp ax,0000                            ; were any files found?
jne final_1
jmp nothing_found                      ; if not, skip ahead ...
final_1:
test b [display],02                    ; allowed to print extra info?
jne final_exit_1go                     ; if not, skip ahead
call peter_line_fix
cmp b [display],00
je final_1a
zprint msg_null                        ; some matches, print a blank line
final_1a:
mov dx,w [entry_count_hi]
mov ax,w [entry_count]                 ; get the big count value of entries
mov ch,00
call dec_print_big                     ; and print it out
mov b [msg_num_entries+5],ah
zprint msg_num_entries                 ; 'entries' message

mov dx,w [files_count_hi]
mov ax,w [files_count]                 ; get the big count value of files
mov ch,00
call dec_print_big                     ; and print it out
mov b [msg_num_files+5],ah
zprint msg_num_files                   ; 'files' message
test b [find_what],80                  ; displaying only hidden or system?
jne zero_hfiles                        ; if so, skip over h/s count display
mov ax,w [hfiles_count]
or ax,w [hfiles_count_hi]              ; were any h/s files found?
cmp ax,0000
je zero_hfiles                         ; if not, skip over h/s count display
zprint msg_hs
mov dx,w [hfiles_count_hi]
mov ax,w [hfiles_count]
mov ch,00
call dec_print_big                     ; display number of h/s files found
zprint msg_hs1
zero_hfiles:                           ; done with h/s files count display
zprint msg_num_files1

mov dx,w [dirs_count_hi]
mov ax,w [dirs_count]                  ; get the big count of directories
mov ch,00
call dec_print_big                     ; and print it out
mov b [msg_num_dirs+0a],ax
cmp ax,0ffff
jne num_dirs_plural
mov b [msg_num_dirs+9],'y'
num_dirs_plural:
zprint msg_num_dirs                    ; 'directories' message
test b [find_what],80                  ; displaying only hidden or system?
jne zero_hdirs                         ; if so, skip over h/s count display
mov ax,w [hdirs_count]
or ax,w [hdirs_count_hi]               ; were any h/s dir's found?
cmp ax,0000
je zero_hdirs                          ; if not, skip over h/s count display
zprint msg_hs
mov dx,w [hdirs_count_hi]
mov ax,w [hdirs_count]
mov ch,00
call dec_print_big                     ; display number of h/s dir's found
zprint msg_hs1
zero_hdirs:                            ; done with h/s dir's count display
zprint msg_num_dirs1

cmp w [max_count],0000                 ; was /f specified?
je final_exit_1b                       ; if not, we're done
mov ax,w [max_count]
cmp ax,w [entry_count]                 ; did we actually reach the /f max?
jne final_exit_1a                      ; if not, we're done
push ax
dosprint msg_maybe_more                ; if so, warn before finishing
pop ax
mov ch,00
call dec_print_small
zprint msg_maybe_more1
jmp final_exit_1a

final_exit_1b:                         ; if /f was not specified
test b [misc_flags],40                 ; but the directory was changed by /g
je final_exit_1a
zprint msg_maybe_more_2                ; print a slightly different warning

final_exit_1a:
mov ax,w [files_count]
or ax,w [files_count_hi]
cmp ax,0000
je final_exit_1
dosprint msg_file_totals
mov ax,w [file_totals]
mov w [009a],ax
mov ax,w [file_totals_hi]
mov w [009c],ax
call show_info_filesize_1
final_exit_1:
call append_restore
doscall2 4c00                          ; and exit with errorlevel 00
nothing_found:
test b [display],02                    ; allowed to print extra info?
jne final_exit_2                       ; if not, skip ahead
zprint msg_nothing                     ; no matches, print a sorry message
final_exit_2:
call append_restore
doscall2 4c01                          ; and exit with errorlevel 01

test_filename:                         ; SHOULD WE PRINT OUT THIS FILENAME?
mov si,w [working_end]                 ; start of found file's name
mov di,offset fs_buf                   ; start of user's filespec
test_fn_1:                             ; loop to compare name with user spec.
mov al,b [si]                          ; al = byte from actual filename
mov ah,b [di]                          ; ah = byte from user filespec
cmp al,ah                              ; do they match?
je test_fn_m                           ; yes!  that's easy!  continue
cmp al,'.'                             ; period in filename?
je test_fn_p                           ; yes, go to special handler for that
cmp al,00                              ; end of filename?
je test_fn_z                           ; yes, go to special handler for that
cmp ah,'?'                             ; question mark in user filespec?
je test_fn_m                           ; yes, accept character
cmp ah,'*'                             ; asterisk in user filespec?
je test_fn_m2                          ; yes, accept character, don't bump di
jmp test_fn_n                          ; mismatch!  don't print this filename
test_fn_p:                             ; period handler:
cmp ah,'*'                             ; at an asterisk in user filespec?
jne test_fn_n                          ; if not, filename mismatch
inc di                                 ; yes, advance di, maybe find a period
jmp test_fn_1                          ; in the user's filespec ...?
test_fn_n:                             ; filename mismatch:
ret                                    ; do nothing, return to caller
test_fn_z:                             ; end of filename:
cmp w [di],00 by '.'                   ; end of no-extension filespec?
je test_fn_y                           ; yes, filename matches.  take it
cmp w [di],'*' by '.'                  ; end of any-extension filespec?
je test_fn_y                           ; yes, filename matches.  take it
cmp w [di],00 by '*'                   ; end of filespec with no extension?
je test_fn_y                           ; take it.  (should never happen?)
cmp w [di],'.' by '*'                  ; stuck at asterisk before period?
jne test_fn_n                          ; if not, this is a definite mismatch
add di,0002                            ; look at the extension:
cmp b [di],00                          ; is this a no-extension filespec?
je test_fn_y                           ; yes, filespec matches.  take it
cmp w [di],00 by '*'                   ; is this an any-extension filespec?
je test_fn_y                           ; yes, filespec matches.  take it
jmp test_fn_n                          ; otherwise, filename doesn't match
test_fn_m:                             ; this character matches:
inc di                                 ; increment pointers
test_fn_m2:                            ; (don't increment di if at an *)
inc si
cmp al,00                              ; hit the end of the filename / spec?
jne test_fn_1                          ; if not, loop back for next chars.

test_fn_y:                             ; FILENAME MATCHES USER FILESPEC:
test b [find_what],40                  ; was /x specified?
je show_attr                           ; if not, skip following /x tests
mov si,w [working_end]                 ; in the filename
mov bl,'.'                             ; search for the period
call find_first                        ; found a period?
je test_fn_n                           ; if not, reject this filename
mov si,ax
inc si                                 ; point just past the period:
cmp w [si],'O' by 'C'                  ; is the extension .COM ?
jne exe_chk_1                          ; if not, skip ahead, try .EXE
add si,0002
cmp b [si],'M'
jne test_fn_n
jmp show_attr                          ; extension is .COM, show it
exe_chk_1:
cmp w [si],'X' by 'E'                  ; is the extension .EXE ?
jne exe_chk_2                          ; if not, skip ahead, try .BAT
add si,0002
cmp b [si],'E'
jne test_fn_n
jmp show_attr                          ; extension is .EXE, show it
exe_chk_2:
cmp w [si],'A' by 'B'                  ; is the extension .BAT ?
jne test_fn_n                          ; if not, don't display this file
add si,0002
cmp b [si],'T'
jne test_fn_n

show_attr:                             ; FILENAME IS ACCEPTABLE:
mov al,b [attrib_care]
mov ah,al
and al,b [attrib_value]                ; attributes we must match
and ah,b [0095]                        ; value of those attribs for this file
cmp al,ah                              ; are they the same?
je show_attr_1                         ; if so, display this file/directory
jmp not_goto                           ; if not, don't display it
show_attr_1:
test b [find_what],80                  ; was /h specified?
je show_attr_2                         ; if not, skip following test
test b [0095],06                       ; is file either hidden or system?
jne show_attr_2
jmp not_goto                           ; if neither, don't display
show_attr_2:                           ; FILENAME AND ATTRIB ARE ACCEPTABLE:
mov ax,w [0098]                        ; get file's date stamp
test b [more_flags],08                 ; do we care about the starting date?
je show_attr_3                         ; if not, don't test it
cmp ax,w [date_1]                      ; compare stamp against starting date
jae show_attr_3                        ; if the same or later, continue
jmp not_goto                           ; if earlier, forget it
show_attr_3:
test b [more_flags],04                 ; do we care about the ending date?
je show_attrib_4                       ; if not, don't test it
cmp ax,w [date_2]                      ; compare stamp against ending date
jbe show_attrib_4                      ; if the same or earlier, continue
jmp not_goto                           ; if later, forget it
show_attrib_4:                         ; THIS ITEM IS WHOLLY ACCEPTABLE:

mov bl,b [display]                     ; which display routine to use?
mov bh,00                              ; convert to a word
shl bx,01                              ; and multiply by two
mov ax,w [disp_routines+bx]            ; get the address of display routine
jmp ax                                 ; to jump to

show_peter:                            ; PETER-STYLE FILENAME OUTPUT:
test b [misc_flags],08                 ; has the current dir been displayed?
jne peter_dir_done                     ; if so, don't display it again
mov bx,offset working                  ; point to start of directory name
mov cx,w [working_end]
cmp cx,(working+3)
je show_peter_1  
dec cx
show_peter_1:
mov ah,02
peter_dir:
mov dl,b [bx]                          ; get a char from directory name
int 21                                 ; and print it out
inc bx
cmp bx,cx                              ; hit the end of the directory name?
jb peter_dir                           ; if not, loop back
zprint msg_null
or b [misc_flags],08                   ; note that dir was printed
peter_dir_done:
cmp b [wide_count],00
je peter_long
mov dl,20
mov ah,02
int 21
int 21
mov cl,0d
mov bx,w [working_end]
peter_wide_1:
mov al,b [bx]
cmp al,00
je peter_wide_2
call peter_case
mov dl,al
doscall 02
inc bx
dec cl
jmp peter_wide_1
peter_wide_2:
mov ah,02
mov dl,20
peter_wide_3:
int 21
dec cl
cmp cl,00
jne peter_wide_3
cmp b [wide_max],02
jne peter_two_x
mov dl,20
doscall 02
call show_info_01

peter_two_x:
dec b [wide_count]
cmp b [wide_count],00
jne peter_wide_4
mov al,b [wide_max]
mov b [wide_count],al
zprint msg_null
peter_wide_4:
jmp name_done
peter_long:
mov dl,20
mov cl,04
mov ah,02
peter_long_1:
int 21
dec cl
cmp cl,00
jne peter_long_1
mov bx,w [working_end]
mov cl,0f
peter_long_2:
mov al,b [bx]
cmp al,00
je peter_long_3
call peter_case
mov dl,al
int 21
inc bx
dec cl
jmp peter_long_2
peter_long_3:
mov dl,20
peter_long_4:
int 21
dec cl
cmp cl,00
jne peter_long_4
call show_info_00
jmp name_done

batch_output:
zprint bat_buf                         ; if so, print it first
mov di,offset working
mov ah,02
mov cl,01
call zprint2
cmp b [bat_args],00
je bat_line_done
mov b [msg_bat_arg+2],'1'
do_bat_args:
zprint msg_bat_arg
inc b [msg_bat_arg+2]
mov al,b [msg_bat_arg+2]
cmp al,b [bat_args]
jna do_bat_args
bat_line_done:
zprint msg_null
jmp name_done

formatted_output:                      ; PRINT OUT /O STRING:
mov bp,offset bat_buf                  ; start at the beginning
fout1:
mov dl,b [bp]                          ; get a character from the buffer
inc bp
cmp dl,01                              ; hit the end of the buffer yet?
jbe fout_x                             ; if so, done with /o string
cmp dl,'&'                             ; is it an ampersand?
je fout_sw                             ; if so, treat as a macro switch
doscall 02                             ; if not, just pring it out
jmp fout1                              ; and loop back for the next char.

fout_sw:                               ; found an ampersand:
mov al,b [bp]                          ; get the next character after it
call force_uc                          ; and convert to uppercase
mov bx,0000                            ; from the top:
fout_sw1:
mov ah,b [fout_switches+bx]            ; find it in the list of switch chars.
cmp ah,00                              ; if not found,
je fout_amp                            ; just print an & and the character
cmp al,ah
je fout_sw2                            ; if found,
inc bx
jmp fout_sw1

fout_sw2:
inc bp                                 ; skip over the switch char.
shl bx,01                              ; multiply the index by two
mov ax,w [fout_routines+bx]            ; get address of appropriate routine
jmp ax                                 ; and go do it!

fout_x:                                ; end of the /o string:
zprint msg_null                        ; terminate the output line
jmp name_done                          ; and we're done printing the filename

fout_amp:                              ; macro &&
mov dl,'&'                             ; just print an ampersand
doscall 02
jmp fout1

fout_ter:                              ; macro &t
zprint msg_null                        ; terminate output line, start another
jmp fout1

fout_esc:                              ; macro &e
mov dl,1b                              ; print an ascii escape
doscall 02
jmp fout1

fout_quo:                              ; macro &q
mov dl,'"'                             ; print a quote mark
doscall 02
jmp fout1

fout_fil:                              ; macro &f
mov si,offset working                  ; print out the full filespec
fout_fil0:
mov ah,02
fout_fil1:
mov dl,b [si]                          ; get a byte from the working buffer
inc si
cmp dl,00                              ; end of buffer yet?
je fout_fil2                           ; if so, exit
int 21                                 ; if not, print the character
jmp fout_fil1                          ; and loop back for the next one
fout_fil2:
jmp fout1

fout_buk:                              ; macro &s
mov si,offset working+0002             ; print out the filespec without
jmp fout_fil0                          ; the drive letter

fout_dir:                              ; macro &d
call find_last_bs_w                    ; find the last backslash in filespec
cmp ax,offset working+0002             ; is this item in the root directory?
ja fout_dir1
inc ax                                 ; if so, stop just after it
fout_dir1:                             ; if not, stop at it
mov cx,ax                              ; save the offset of character to zero
mov ah,02
mov bx,offset working                  ; from the start of the working buffer
fout_dir2:
mov dl,b [bx]                          ; get a character from the dir name
inc bx
int 21                                 ; and print it out
cmp bx,cx                              ; printed the last character yet?
jb fout_dir2                           ; no, loop back
jmp fout1                              ; yes, done

fout_pat:                              ; macro &p
call find_last_bs_w                    ; find the last backslash in filespec
inc ax                                 ; stop just after it
jmp fout_dir1                          ; print directory name with &d routine

fout_nam:                              ; macro &n
call find_last_bs_w                    ; find the last backslash in filespec
mov si,ax
inc si                                 ; starting just after it,
jmp fout_fil0                          ; print filespec with &f routine

fout_roo:                              ; macro &r
call find_last_bs_w                    ; find the last backslash in filespec
mov si,ax
inc si                                 ; starting just after it,
mov ah,02
fout_roo1:
mov dl,b [si]                          ; get a character from filespec
inc si
cmp dl,00                              ; end of filespec yet?
je fout_roo2                           ; if so, done
cmp dl,'.'                             ; found the extension separator yet?
je fout_roo2                           ; if so, done
int 21                                 ; otherwise, print it out
jmp fout_roo1                          ; and loop back for the next char
fout_roo2:
jmp fout1

fout_ext:                              ; macro &x
call find_last_bs_w                    ; find the last backslash in filespec
mov si,ax
inc si                                 ; starting just after it,
mov bl,'.'
call find_last                         ; find the period
je fout_roo2                           ; if not found, simply exit
mov si,ax                              ; if found,
inc si                                 ; starting just after the period,
mov ah,02
fout_ext1:
mov dl,b [si]                          ; get a character from the extension
inc si
cmp dl,00                              ; null?  if so, done
je fout_roo2
int 21                                 ; print it out
jmp fout_ext1                          ; and loop back for the next

fout_att:                              ; macro &a
mov ah,b [0095]                        ; get attributes byte in .ah
mov si,0000                            ; character before 'A'
test ah,20                             ; set according to 'archive me' bit
call fout_att2
mov si,0003                            ; character before 'S'
test ah,04                             ; set according to 'system' bit
call fout_att2
mov si,0006                            ; character before 'H'
test ah,02                             ; set according to 'hidden' bit
call fout_att2
mov si,0009                            ; character before 'R'
test ah,01                             ; set according to 'read-only' bit
call fout_att2
dosprint msg_attrib_2                  ; print the whole mess out
jmp fout1                              ; done with this macro
fout_att2:
je fout_att3
mov b [msg_attrib_2+si],'+'            ; bit set, poke in a '+'
ret
fout_att3:
mov b [msg_attrib_2+si],'-'            ; bit clear, poke in a '-'
ret

fout_bra:                              ; macro &b
call display_attributes                ; just use the existing routine!
jmp fout1                              ; (pretty cheap, huh?)

fout_let:                              ; macro &l
mov dl,b [working+0]
doscall 02                             ; just print the first two characters
mov dl,b [working+1]                   ; also pretty cheap
int 21
jmp fout1

fout_win:                              ; macro &w
cmp w [lfn_seg],0000                   ; is there an lfn buffer?
jne fout_win2
jmp fout_fil                           ; if not, use the &f routine instead
fout_win2:
mov si,offset working                  ; ds:si points to 8.3 filename
mov es,w [lfn_seg]
mov di,0000                            ; es:di points to lfn buffer
mov cx,8002
doscall2 7160                          ; truename:  convert to long filename
jnc fout_win3
mov es,w [tree_seg]                    ; if any problem, restore .es
jmp fout_fil                           ;    and use the &f routine instead
fout_win3:
mov si,0000
call fout_lfn_buf                      ; print out long filename
jmp fout1

fout_zin:                              ; macro &z
cmp w [lfn_seg],0000                   ; is there an lfn buffer?
jne fout_zin2
jmp fout_nam                           ; if not, use the &n routine instead
fout_zin2:
mov si,offset working                  ; ds:si points to 8.3 filename
mov es,w [lfn_seg]
mov di,0000                            ; es:di points to lfn buffer
mov cx,8002
doscall2 7160                          ; truename:  convert to long filename
jnc fout_zin1
mov es,w [tree_seg]                    ; if any problem, restore .es
jmp fout_nam                           ;    and use the &n routine instead
fout_zin1:
mov ax,0000
mov si,ax
fout_zin3:
mov dl,b [es:si]                       ; scan through long filename
inc si
cmp dl,00                              ; hit the final null?
je fout_zin5                           ; if so, done scanning -- print lfn
cmp dl,'\'
jne fout_zin3                          ; found a backslash?
mov ax,si                              ; if so, note its position
jmp fout_zin3
fout_zin5:                             ; done scanning -- print lfn
mov si,ax                              ; starting just after the last \
call fout_lfn_buf
jmp fout1

fout_lfn_buf:
mov dl,'"'
doscall 02
mov es,w [lfn_seg]
fout_lfn_buf2:
mov dl,b [es:si]
inc si
cmp dl,00
je fout_lfn_buf4
int 21
jmp fout_lfn_buf2
fout_lfn_buf4:
mov dl,'"'
int 21
mov es,w [tree_seg]
ret

fout_dat:
call show_date
jmp fout1

fout_tim:
call show_time
jmp fout1

fout_siz:
test b [0095],10
jne fout_siz_x
mov dx,w [009c]
mov ax,w [009a]
mov ch,80
call dec_print_big
fout_siz_x:
jmp fout1

plain_jane:
call display_attributes

bare_naked:
zprint working
jmp name_done

old_info:
zprint working
call show_info
jmp name_done

sd_bare:
zprint working+2
jmp name_done

lfn_output:                            ; OUTPUT VIA /L METHOD:
mov si,offset working                  ; ds:si points to 8.3 filename
mov es,w [lfn_seg]
mov di,0000                            ; es:di points to lfn buffer
mov cx,8002
doscall2 7160                          ; truename:  convert 8.3 to long
jnc lfn_output_2
jmp old_info                           ; if any problem, use the /i routine
lfn_output_2:
mov si,0000
test b [more_flags],80
jne lfn_output_3
call find_es_null
mov si,0000
cmp ax,004d
jb lfn_output_3
mov w [es:004a],'.' by '.'
mov w [es:004c], 00 by '.'
lfn_output_3:
call fout_lfn_buf
zprint msg_null
call show_info
jmp name_done

name_done:                             ; DONE PRINTING FILENAME BY WHATEVER
inc w [entry_count]                    ; MEANS:
jne attr_done_0
inc w [entry_count_hi]                 ; increment the big entry count
attr_done_0:
test b [0095],10                       ; file or directory?
jne attr_done_dir
inc w [files_count]
jne add_filesize
inc w [files_count_hi]                 ; increment the big file count
add_filesize:
mov ax,w [009a]
add w [file_totals],ax
mov ax,w [009c]
adc w [file_totals_hi],ax
test_hfiles:
test b [0095],06                       ; is this file hidden or system?
je attr_done_1                         ; if not, don't bump h/s files count
inc w [hfiles_count]
jne attr_done_1
inc w [hfiles_count_hi]                ; increment the big h/s files count
jmp attr_done_1
attr_done_dir:
inc w [dirs_count]
jne test_hdirs
inc w [dirs_count_hi]                  ; increment the big directory count
test_hdirs:
test b [0095],06                       ; is this directory hidden or system?
je attr_done_1                         ; if not, don't bump h/s dir's count
inc w [hdirs_count]
jne attr_done_1
inc w [hdirs_count_hi]                 ; increment the big h/s dir's count
attr_done_1:
test b [misc_flags],80                 ; was /g specified?
je not_goto                            ; if not, don't worry about it
cmp w [max_count],0000                 ; /g:  was a count specified?
je goto_ask                            ; no, ask the user whether to go
mov ax,w [max_count]                   ; yes:  is this the final find?
cmp ax,w [entry_count]
jne not_goto                           ; no, never mind
je goto_dir                            ; final find, go to directory
goto_ask:                              ; /g specified, no count:
dosprint msg_go_ask
call ask_yorn                          ; ask user whether or not to go
jne not_goto                           ; if no, forget it
goto_dir:
call go_there                          ; go to directory
jmp final_exit                         ; and exit this program

not_goto:
cmp w [max_count],0000                 ; was there a /f specified?
je attr_done_2                         ; if not, exit
mov ax,w [max_count]                   ; /f was specified:
cmp ax,w [entry_count]                 ; have we shown enough entries?
jne attr_done_2                        ; if not, exit
pop ax                                 ; whoops, all done:  clear the stack
jmp final_exit                         ;   and i am outta here!
attr_done_2:
ret

display_attributes:
mov si,0000                            ; pointer to bit-name letters
mov cl,20                              ; highest bit is #5 (archive)
attr_loop:
mov al,'.'                             ; assume a space
test b [0095],cl                       ; is this bit set?
je attr_go                             ; clear, use the space
mov al,b [attr1+si]                    ; set, get the bit-name letter instead
attr_go:
inc si                                 ; point to the next letter
mov b [msg_attrib+si],al               ; and poke space or letter into string
attr_skip:
shr cl,1                               ; and shift right to next bit
cmp cl,08                              ; bit 3 (volume label/lfn) we don't
je attr_skip                           ; care about, so skip it
cmp cl,00                              ; run out of bits?
jne attr_loop                          ; no, loop back for next
dosprint msg_attrib                    ; yes, print the attribute string
ret

show_info:                             ; DISPLAY ADDITIONAL FILE INFO:
dosprint msg_info_1                    ; tab in a few spaces
show_info_00:
call display_attributes                ; display file's attributes
show_info_01:
call show_date
dosprint msg_info_space                ; and tab in some
call show_time

cmp b [wide_max],02                    ; peter-two display?
jne show_info_25
ret                                    ; if so, exit from show_info routine

show_info_25:
test b [0095],10                       ; is this item a subdirectory?
jne show_info_30                       ; if so, branch ahead

show_info_filesize:
mov b [dp_min],0a
show_info_filesize_1:
mov dx,w [009c]
mov ax,w [009a]                        ; file, not dir:  get the file's size
mov ch,00
call dec_print_big                     ; and display it
mov dx,w [009c]
mov ax,w [009a]
cmp dx,0010                            ; is the file 1 mb or larger?
jae show_info_mb                       ; if so, also show file size in mb
jmp show_info_kb                       ; otherwise, show as kilobytes
show_info_30:
dosprint msg_info_dir                  ; directory, say so
jmp show_info_32                       ; and exit
show_info_kb:                          ; report file size in kb:
dosprint msg_info_open                 ; display the open parenthesis
mov dx,w [009c]
mov ax,w [009a]                        ; dword file size
shr ax,0a                              ; divide low word by 1024
shl dx,06                              ; get most significant bits
or ax,dx
mov ch,00
mov b [dp_min],03
call dec_print_small                   ; and display kb value
mov ax,w [009a]                        ; get fractional kb
shr ax,02                              ; in al (0 to 255)
call show_fraction                     ; and display fractional kb
dosprint msg_info_kb                   ; close parenthesis
jmp show_info_32                       ; done
show_info_mb:                          ; report file size in mb:
dosprint msg_info_open                 ; display open parenthesis
mov ax,w [009c]
shr ax,04                              ; file size in mb
mov ch,00
mov b [dp_min],03
call dec_print_small                   ; display mb value
mov ax,w [009a]
mov dx,w [009c]
shr ax,0c
shl dx,04
or ax,dx                               ; fractional mb value (0-255) in al
call show_fraction                     ; display fractional mb
dosprint msg_info_mb                   ; close parenthesis
show_info_32:
zprint msg_null                        ; done with file info, complete line
ret

show_date:                             ; display file's date stamp:
mov al,b [country_date]                ; check country's date format
cmp al,01
je show_datee                          ; 01, european date format
cmp al,02
je show_datej                          ; 02, japanese date format
mov ax,w [0098]
and ah,01
shr ax,05                              ; get month value in al
mov ah,80                              ; suppress leading zeroes
call time_print                        ; print month
mov dl,b [country_dsep]
doscall 02                             ; and the date separator
mov ax,w [0098]                        ; file's date stamp:
and al,1f                              ; get day value in al
mov ah,00                              ; print leading zeroes
call time_print                        ; print day
mov dl,b [country_dsep]
doscall 02                             ; and the date separator
mov ax,w [0098]                        ; file's date stamp:
shr ax,09                              ; get year value in al
add ax,01980xd                         ; and normalize
mov ch,80
call dec_print_small                   ; print the year
ret

show_datee:                            ; show date, european:
mov ax,w [0098]                        ; file's date stamp:
and ax,001f                            ; get day value in al
or ah,80
call time_print                        ; print day without leading zeroes
mov dl,b [country_dsep]
doscall 02                             ; and the date separator
mov ax,w [0098]                        ; file's date stamp:
and ah,01
shr ax,05                              ; get month value in al
call time_print                        ; print month, with leading zeroes
mov dl,b [country_dsep]
doscall 02                             ; and the date separator
mov ax,w [0098]                        ; file's date stamp:
shr ax,09                              ; get year value in al
add ax,01980xd                         ; and normalize
mov ch,80
call dec_print_small                   ; print the year
ret

show_datej:                            ; show date, japanese:
mov ax,w [0098]                        ; file's date stamp:
shr ax,09                              ; get year value in al
add ax,01980xd                         ; and normalize
mov ch,80
call dec_print_small                   ; print the year
mov dl,b [country_dsep]
doscall 02                             ; and the date separator
mov ax,w [0098]                        ; file's date stamp:
and ah,01
shr ax,05                              ; get month value in al
call time_print                        ; print month, with leading zeroes
mov dl,b [country_dsep]
doscall 02                             ; and the date separator
mov ax,w [0098]                        ; file's date stamp:
and ax,001f                            ; get day value in al
call time_print                        ; print day with leading zeroes
ret

show_time:                             ; display file's time stamp:
mov ax,w [0096]                        ; file's time stamp:
shr ax,0b                              ; get hour in al
cmp b [country_time],00                ; do the locals use a 24-hour clock?
jne show_time_20                       ; if so, skip all am / pm fiddling
mov b [msg_info_ampm+1],'a'            ; assume a.m.
cmp al,00                              ; is it midnight?
jne show_time_15                       ; no, continue ....
mov al,0c                              ; display midnight as '12 am'
jmp show_time_20
show_time_15:                          ; not midnight:
cmp al,0c                              ; is it before noon?
jb show_time_20                        ; if so, don't need to manipulate it
mov b [msg_info_ampm+1],'p'            ; noon or later:  display as 'pm'
cmp al,0c                              ; is it noon?
je show_time_20                        ; if so, display as '12 pm'
sub al,0c                              ; otherwise, normalize hours
show_time_20:                          ; done fiddling with hours:
mov ah,80                              ; suppress leading zeroes
call time_print                        ; and print hours
mov dl,b [country_tsep]
doscall 02                             ; followed by the time separator char
mov ax,w [0096]                        ; file's time stamp:
and ah,07
shr ax,05                              ; get minutes in al
call time_print                        ; print minutes with leading zeroes
cmp b [country_time],00                ; do the locals use a 24-hour clock?
jne show_time_30
dosprint msg_info_ampm                 ; if not, display a.m. or p.m.
ret
show_time_30:
dosprint msg_info_space                ; if so, just print some blanks
ret

show_fraction:                         ; al contains a value 0-255:
push ax                                ; save it
mov dl,b [country_deci]
doscall 02                             ; display a decimal point
pop ax                                 ; al contains 0-255:
mov ah,00                              ; convert to word length
mov bl,64
mul bl                                 ; multiply by 100
test al,80
je show_frac_fix
cmp ah,063
jae show_frac_fix
inc ah
show_frac_fix:
mov al,ah                              ; then divide by 256
mov ah,00                              ; and fall through

time_print:
mov dx,'0' by '0'
time_print_1:
cmp al,0a
jb time_print_2
sub al,0a
inc dl
jmp time_print_1
time_print_2:
add dh,al
test ah,80
je time_print_3
cmp dl,'0'
jne time_print_3
mov dl,20
time_print_3:
mov ah,02
int 21
mov dl,dh
int 21
ret

peter_line_fix:
test b [misc_flags],08
je peter_line_x
zprint msg_null
and b [misc_flags],0f7
cmp b [wide_count],00
je peter_line_x
mov al,b [wide_max]
cmp b [wide_count],al
je peter_line_x
zprint msg_null
mov al,b [wide_max]
mov b [wide_count],al
peter_line_x:
ret

path_bad:                              ; no path variable:
jmp main_loop                          ; exit.  search only current directory

use_path:                              ; FILL TREE BUFFER FROM PATH VARIABLE:
doscall 19                             ; get the current drive
add al,'A'                             ; and convert to a letter
mov ah,':'                             ; add a colon
mov es,w [tree_seg]                    ; segment of tree buffer
mov si,0000                            ; at the beginning:
mov w [es:si],ax                       ; poke the drive letter and colon
add si,0002
mov b [es:si],'\'                      ; add a backslash
inc si
doscall 19                             ; get the current drive again
mov dl,al
inc dl                                 ; convert to a 1-based number in dl
mov ds,w [tree_seg]                    ; ds:si points right after the \
doscall 47                             ; add the current directory after \
push cs
pop ds                                 ; put ds back where god intended
mov es,w [tree_seg]                    ; es points to the tree buffer 
mov si,0000
call find_es_null                      ; find the terminal null
cmp ax,0004                            ; is the current directory the root?
jb use_path_fix
mov b [es:si],'\'                      ; if not, add a final backslash
inc si
use_path_fix:
mov w [es:si],0000                     ; add a double-null
inc si
mov w [tree_end],si                    ; and save offset of the 2nd null

mov ax,w [002c]                        ; program's psp contains
mov w [env_seg],ax                     ; segment of an environment block
cmp ax,0008                            ; is it above 8?
jna path_bad                           ; if not, something is very wrong

mov bp,offset var_path                 ; look for the path= variable
call find_env_var
jne path_bad                           ; if no path= variable, abort
mov w [env_temp],si                    ; save pointer

path_loop:
mov es,w [env_seg]
mov si,w [env_temp]                    ; pointer into path value
mov di,offset working                  ; pointer into working buffer
mov dl,00                              ; no last character
path_loop_1:
mov al,b [es:si]                       ; get a byte from path value
inc si                                 ; and increment pointer
call force_uc                          ; no lowercase, please
cmp al,20                              ; is it a space?
je path_loop_1                         ; if so, ignore it
cmp al,09                              ; is it a tab?
je path_loop_1                         ; if so, ignore it
cmp al,'/'                             ; is it a slash? (should never happen)
jne path_loop_2
mov al,'\'                             ; if so, substitute a backslash
path_loop_2:
cmp al,';'                             ; semicolon = end of directory name
je path_loop_3
cmp al,00                              ; null = end of directory name
je path_loop_3
mov b [di],al                          ; otherwise, copy into working buffer
inc di
mov dl,al                              ; and save this character as last char
jmp path_loop_1                        ; and loop back for next
path_loop_3:                           ; directory name in working buffer:
cmp di,offset working                  ; is there really?
je path_whoops                         ;    maybe not ...
cmp dl,'\'                             ; was the last character a backslash?
je path_loop_4
mov b [di],'\'                         ; if not, add a backslash to the end
inc di
path_loop_4:
mov w [env_temp],si                    ; save pointer into environment
mov b [di],00                          ; null-terminate the working dir name
mov dl,al                              ; and stash the semicolon or null
mov si,offset working                  ; compare the directory name
mov es,w [tree_seg]                    ; with the first directory in the
mov di,0000                            ; tree buffer (the current directory)
call compare_si_esdi_z                 ; are they identical?
je path_loop_5                         ; if so, don't add this directory
mov si,offset working                  ; probably not a duplicate:
mov di,w [tree_end]
call copy_si_esdi_z                    ; copy directory onto end of tree
mov b [es:di],00                       ; and add a second null
mov w [tree_end],di                    ; save address of second null
path_loop_5:
cmp dl,00                              ; found the null at end of path var?
jne path_loop                          ; no, loop back for next dir name
path_bad_2:
jmp main_loop                          ; done filling tree_buffer from path
path_whoops:                           ; working buffer is empty!  this may
cmp al,00                              ; happen with pathological paths.
je path_bad_2                          ; abort if end of variable reached;
mov w [env_temp],si                    ; otherwise, attempt to continue
jmp path_loop                          ; parsing path variable.


go_there:
test b [0095],10
jne go_there_10
call find_last_bs_w
cmp ax,working + 0002
ja go_there_5
inc ax
go_there_5:
mov si,ax
mov b [cs:si],00
push si
go_there_10:
mov dx,offset working
doscall 3b
mov dl,b [working]
sub dl,'A'
doscall 0e
or b [misc_flags],40
test b [0095],10
jne go_there_20
pop si
mov b [si],'\'
go_there_20:
ret

ask_yorn:                              ; routine used by /G to get a key:
mov ah,01
int 16                                 ; check keyboard buffer
je yorn                                ; if empty, continue
mov ah,00
int 16                                 ; if not, retrieve key from buffer
jmp ask_yorn                           ; and loop back
yorn:                                  ; key buffer is empty:
mov ah,00
int 16                                 ; get a key
cmp ax,3d00
je yorn_abort                          ; f3 = abort program
cmp al,1b
je yorn_abort                          ; esc = abort program
cmp al,11
je yorn_abort                          ; control-q = abort program (^c, ^brk)
cmp ax,3c00
je yorn_cont                           ; f2 = stop asking!
and al,0df                             ; force uppercase
cmp al,'Q'
je yorn_abort                          ; Q = abort program
cmp al,'C'
je yorn_cont                           ; C = stop asking!
cmp al,'N'
je yorn_no                             ; N = no  (ordinary answer)
cmp al,'Y'
jne yorn                               ; Y = yes (ordinary answer)
yorn_no:
push ax                                ; save the keystroke
dosprint msg_unpause                   ; erase the prompt line
mov al,b [lines_max]
mov b [lines_count],al                 ; reset line count; prevent pausing
pop ax                                 ; get the keystroke:
cmp al,'Y'                             ; was it Yes?
ret

yorn_abort:                            ; user pressed f3 or esc:
jmp pause_brk                          ; treat just like pause routine would

yorn_cont:                             ; user pressed f2 or q:
and b [misc_flags],7f                  ; turn /G off
mov al,'N'                             ; and act like the user pressed n
jmp yorn_no

dupe_drives:                           ; CHECK FOR DUPLICATE DRIVE MAPPINGS:
test b [misc_flags],10                 ; did the user specify /M ?
jne ddrv1                              ; if so, exit this routine
test b [find_what],08                  ; did the user specify /T ?
jne ddrv1                              ; if so, exit this routine
test b [more_flags],40                 ; did the user specify a drive(s)?
je ddrv2                               ; if not, continue
ddrv1:
ret
ddrv2:                                 ; initialize dupe-drive workspace:
mov ax,':' by 'a'                      ; start with drive a:
mov bx,0000                            ; and slot #0
mov es,w [tree_seg]                    ; use tree buffer for workspace
ddrv3:
mov w [es:bx],ax                       ; poke drive letter into slot
mov b [es:bx+2],00                     ; and zero-terminate it
add bh,01                              ; next slot
add al,01                              ; and next drive letter
cmp al,'z'                             ; run out of drive letters yet?
jna ddrv3                              ; if not, loop back
mov w [tree_end],0000                  ; initialize assign-list index
ddrv4:
mov bx,w [tree_end]                    ; get assign-list index
mov si,4000                            ; offset of local-name buffer
mov di,4100                            ; offset of network-name buffer
mov es,w [tree_seg]                    ; segment of network-name buffer
push es
pop ds                                 ; segment of local-name buffer
mov b [ds:si],00                       ; empty the local-name buffer
mov b [es:di],00                       ; empty the network-name buffer
doscall2 5f02                          ; get assign-list entry:
push cs
pop ds                                 ; get my data segment back!
jc ddrv11                              ; if out of entries, exit
mov es,w [tree_seg]                    ; segment of dupe-drive workspace
mov ax,w [es:4000]                     ; check the local name:
cmp ah,':'                             ; is the second character a colon?
jne ddrv10                             ; if not, continue with next entry
cmp al,'A'
jb ddrv10                              ; is the first character an uppercase
cmp al,'Z'                             ; letter?
ja ddrv10                              ; if not, continue with next entry
sub al,'A'                             ; convert drive letter to number
mov bh,al
mov bl,00                              ; bx contains 256*drive
mov si,4100                            ; si points to network-name buffer
mov cl,00                              ; no backslashes copied yet
ddrv6:
mov al,b [es:si]                       ; copy the network name
mov b [es:bx],al                       ; to the drive's slot (256*drive)
inc si
inc bx
cmp al,'\'                             ; was that a backslash?
jne ddrv7
inc cl                                 ; if so, count it
cmp cl,04                              ; was it the fourth backslash?
je ddrv8                               ; if so, force end of netname
ddrv7:
cmp al,00                              ; was character the terminal null?
jne ddrv6                              ; if not, loop back for next char
je ddrv10                              ; if so, done copying netname
ddrv8:                                 ; four backslashes:
mov b [es:bx],00                       ; null-terminate the destination name
ddrv10:                                ; increment assign-list entry
inc w [tree_end]
jmp ddrv4
ddrv11:                                ; DONE BUILDING DUPE-DRIVE WORKSPACE:
mov es,w [tree_seg]
mov w [tree_end],0100                  ; start upper drive at 1 (b:)
ddrv12:
mov w [env_temp],0000                  ; start lower drive at 0 (a:)
ddrv13:
mov bx,w [tree_end]                    ; bx points to upper drive slot
mov bp,w [env_temp]                    ; bp points to lower drive slot
mov si,0000                            ; start at beginning of netname
ddrv14:
mov al,b [es:bx+si]                    ; get a character from upper netname
cmp al,b [es:bp+si]                    ; compare against lower netname
jne ddrv16                             ; if mismatch, try next lower drive
inc si                                 ; character matches:
cmp al,00                              ; was it the terminal null?
jne ddrv14                             ; if not, loop back for next char.
mov al,b [tree_end+1]                  ; get the drive number
call drive_bit1                        ; and convert to a bit pointer
or b [ddrv_table+bx],ah                ; set the bit in the dupe drive table
jmp ddrv18                             ; and move on to the next upper drive
ddrv16:                                ; increment lower drive:
mov bx,w [env_temp]
add bx,0100
mov w [env_temp],bx
cmp bx,w [tree_end]
jne ddrv13
ddrv18:                                ; increment upper drive:
mov bx,w [tree_end]
add bx,0100
mov w [tree_end],bx
cmp bx,1a00
jb ddrv12
ret                                    ; done checking for dupe drives

drive_bit:                             ; CONVERT DRIVE LETTER TO BIT POINTER:
sub al,'A'                             ; al holds 0-based drive number
drive_bit1:
mov bl,al 
shr bl,03
mov bh,00                              ; bx holds drive/8
mov cl,al
and cl,07                              ; cl holds (drive and 07)
mov ah,01
shl ah,cl                              ; ah holds 2^(drive and 07)
ret                                    ; return byte ptr. in bx and bit in ah

parse_env:
mov ax,w [002c]                        ; program's psp contains
mov w [env_seg],ax                     ; segment of environment block
cmp ax,0008                            ; is it above 8?
ja parse_env_1                         ; if so, continue
parse_env_0:
ret                                    ; bad environment segment, abort
parse_env_1:
mov bp,offset var_locate
call find_env_var                      ; find any 'locate' variable
jne parse_env_0                        ; exit if not found
or b [misc_flags],01                   ; note: parsing from environment
parse_env_2:
mov al,b [es:si]                       ; get a character from environment:
call force_uc                          ; uppercase it
inc si
cmp al,00                              ; end of the environment var?
je parse_env_x                         ; if so, exit
call test_switch                       ; switch or space?
je parse_env_2                         ; if so, ignore it
mov di,0ffff
parse_env_4:
inc di                                 ; look at next char. in switch table
cmp b [switches+di],00                 ; is it a null?
je parse_env_syn                       ; if so, syntax error
cmp b [switches+di],al                 ; is it equal to the current char?
jne parse_env_4                        ; if not, keep looking
shl di,01
mov bx,w [switch_routines+di]          ; found it:  get the routine's address
jmp bx                                 ; and go there
parse_env_x:                           ; done parsing from enviroment block:
and b [misc_flags],0fe                 ; note it and exit
ret
parse_env_syn:                         ; illegal command in environment:
mov b [msg_env_err1],al
call append_restore
dosprint msg_env_err                   ; print error message
doscall2 4c10                          ; and abort

find_env_var:
cmp w [env_seg],0008                   ; valid segment for environment block?
ja find_env_var0                       ; if so, continue
mov al,00
cmp al,0ff                             ; if not,
ret                                    ; return with z clear for failure
find_env_var0:
mov es,w [env_seg]                     ; segment of environment block
mov bx,0000                            ; start of table:
find_env_var1:
mov si,0000
find_env_var2:
mov al,b [es:bx+si]                    ; get a character from env table
cmp al,b [bp+si]                       ; and compare against desired name
jne find_env_var8                      ; mismatch, find next var name
inc si
cmp al,'='                             ; found the terminal = ?
jne find_env_var2                      ; no, continue comparing names
mov ax,si
add bx,ax
mov si,bx                              ; return offset of char. after =
cmp al,al                              ; with z set for success
ret
find_env_var8:                         ; look for next variable name:
inc bx                                 ; scan forward
cmp b [es:bx],00                       ; until the first null
jne find_env_var8
inc bx                                 ; the character after the null:
cmp b [es:bx],00                       ; is it another null?
jne find_env_var1                      ; no, found the next var name -- cont.
cmp b [es:bx],0ff                      ; out of variables - exit with z clear
ret

test_switch:                           ; EXAMINE CHARACTER IN .AL:
cmp al,'/'                             ; if a switch, exit with carry clear
je test_sw_1                           ;    and zero set
cmp al,'-'                             ; otherwise, return flags as in
je test_sw_1                           ;    following routine
cmp al,','
je test_sw_1

test_space:                            ; EXAMINE CHARACTER IN .AL:
cmp al,0d                              ; if return, exit with carry set
je test_sw_cr                          ; if space, exit with carry clear
cmp al,20                              ;    and zero set
je test_sw_1                           ; otherwise, exit with carry and
cmp al,09                              ;    zero clear
test_sw_1:
clc
ret
test_sw_cr:
stc
ret

test_digit:                            ; EXAMINE CHARACTER IN .AL:
cmp al,'0'
jb test_digit_x                        ; is it a digit?
cmp al,'9'                             ; if so, exit with zero flag set
ja test_digit_x                        ; if not, exit with zero flag clear
cmp al,al
test_digit_x:
ret

test_dsep:                             ; EXAMINE CHARACTER IN .AL:
cmp al,'-'
je test_dsep_x                         ; is it a date separator?
cmp al,'/'                             ; if so, exit with zero flag set
je test_dsep_x                         ; if not, exit with zero flag clear
cmp al,'.'
test_dsep_x:
ret

peter_case:
test b [0095],10
je force_lc

force_uc:                              ; FORCE CHARACTER IN .AL TO UPPERCASE:
cmp al,'a'
jb force_uc_1
cmp al,'z'
ja force_uc_1
and al,0df
force_uc_1:
ret

force_lc:                              ; FORCE CHARACTER IN .AL TO LOWERCASE:
cmp al,'A'
jb force_lc_1
cmp al,'Z'
ja force_lc_1
or al,20
force_lc_1:
ret

find_last_bs_w:
mov si,offset working
find_last_bs:
mov bl,'\'

find_last:                             ; SEARCH ASCIIZ STRING AT [SI] FOR
mov ax,0000                            ; LAST OCURRENCE OF CHARACTER IN BL:
find_last_1:
mov bh,b [si]                          ; if found, exit with offset of last
cmp bh,00                              ; match in ax and zf clear
je find_last_x
cmp bh,bl                              ; if not found, exit with ax=0000
jne find_last_2                        ; and zf set
mov ax,si
find_last_2:
inc si
jmp find_last_1
find_last_x:
cmp ax,0000
ret

find_first:                            ; SEARCH ASCIIZ STRING AT [SI] FOR
mov ax,0000                            ; FIRST OCURRENCE OF CHARACTER IN BL:
find_first_1:
mov bh,b [si]                          ; if found, exit with offset of first
cmp bh,00                              ; match in ax and si, and zf clear
je find_first_x
cmp bh,bl                              ; if not found, exit with ax=0000
jne find_first_2                       ; and zf set
mov ax,si
jmp find_first_x
find_first_2:
inc si
jmp find_first_1
find_first_x:
cmp ax,0000
ret

find_null:                             ; FIND FIRST NULL BYTE AFTER [SI]:
cmp b [si],00
je find_null_x                         ; return offset in si and ax
inc si
jmp find_null
find_null_x:
mov ax,si
ret

find_es_null:                          ; FIND FIRST NULL BYTE AFTER [ES:SI]:
cmp b [es:si],00
je find_null_x                         ; return offset in si and ax
inc si
jmp find_es_null

copy_si_di_z:                          ; COPY ASCIIZ STRING FROM [SI] TO [DI]
mov al,b [si]
mov b [di],al                          ; will malf if copying up to an
inc si                                 ; overlapping block
inc di
cmp al,00
jne copy_si_di_z
ret

copy_si_esdi_z:                        ; COPY ASCIIZ FROM [SI] TO [ES:DI]:
mov al,b [si]
mov b [es:di],al
inc si
inc di
cmp al,00
jne copy_si_esdi_z
ret

copy_essi_di_z:                        ; COPY ASCIIZ FROM [ES:SI] TO [DI]:
mov al,b [es:si]
mov b [di],al
inc si
inc di
cmp al,00
jne copy_essi_di_z
ret

copy_essi_esdi_zz:                     ; COPY BLOCK FROM [ES:SI] TO [ES:DI]:
mov al,b [es:si]                       ; block ends in null word (not byte)
mov b [es:di],al
inc si
inc di
cmp al,00
jne copy_essi_esdi_zz
cmp b [es:si],00
jne copy_essi_esdi_zz
mov b [es:di],00
ret

compare_si_esdi_z:                     ; COMPARE ASCIIZ STRING AT [SI] TO
mov al,b [si]                          ; STRING AT [ES:DI]:
cmp al,b [es:di]
jne compare_x                          ; returns zf set if strings are equal,
cmp al,00                              ; zf clear if strings are not equal
je compare_x
inc si
inc di
jmp compare_si_esdi_z
compare_x:
ret

lowercase_si_z:                        ; FORCE ASCIIZ STRING AT [SI] TO
mov al,b [si]                          ; LOWERCASE:
cmp al,00
je lowercase_x
cmp al,'A'
jb lowercase_1
cmp al,'Z'
ja lowercase_1
or al,20
mov b [si],al
lowercase_1:
inc si
jmp lowercase_si_z
lowercase_x:
ret

zprint1:                               ; PRINT ASCIIZ STRING, PAUSE IF NEEDED
mov ah,02                              ; dos print-character function
mov cl,00                              ; no ctrl-a character found
zprint2:
mov dl,b [di]                          ; get a character
inc di                                 ; and increment pointer
cmp dl,01                              ; found a control-a?
jne zprint3                            ; no, continue
mov cl,01                              ; yes, note it
jmp zprint2                            ; and loop back
zprint3:
cmp dl,00                              ; found the terminal null?
je zprintx                             ; if so, exit the print loop
cmp dl,0ff                             ; print-nothing character?
je zprint2                             ; if so, ignore it and loop back
int 21                                 ; if not, print the character
jmp zprint2                            ; and loop back for more
zprintx:                               ; found the terminal null:
cmp cl,01                              ; was there a control-a in the string?
je zprint_3                            ; if so, exit with no cr/lf
mov dl,0d
int 21                                 ; print a return
mov dl,0a
int 21                                 ; and a line feed
cmp b [0019],01                        ; is output redirected?
jne zprint_add                         ; if so, skip check for control key
mov ah,02
int 16                                 ; get keyboard shift status
test al,04                             ; was control pressed?
je zprint_add                          ; if not, don't do control-key delay
push es
mov es,0040                            ; segment for bios data area
keydelay1:
test b [es:006c],01                    ; wait for an even jiffy
jne keydelay1
keydelay2:
test b [es:006c],01                    ; then wait for an odd jiffy
je keydelay2
pop es
zprint_add:
cmp b [lines_max],00                   ; are we counting lines?
jne zprint_c                           ; yes, count this one
zprint_3:                              ; no, exit this routine
ret
zprint_c:                              ; counting lines:
dec b [lines_count]                    ; decrement line count
cmp b [lines_count],00                 ; time for a pause yet?
jne zprint_3                           ; no, exit routine
mov al,b [lines_max]                   ; time for a pause --
mov b [lines_count],al                 ; reset line count and fall through

pause:                                 ; PAUSE TO PREVENT SCROLLING:
dosprint msg_pause                     ; print hit-a-key message
pause_1:
mov ah,01
int 16                                 ; any keys in keyboard buffer?
je pause_2                             ; no, wait for one
mov ah,00                              ; yes, remove a key from buffer
int 16
jmp pause_1                            ; and loop back
pause_2:                               ; keyboard buffer is empty now:
mov ah,00
int 16                                 ; wait for a keystroke
call force_uc
cmp al,0d                              ; enter key?
je pause_cr                            ; yes, scroll line
cmp al,20                              ; space bar?
je pause_sp                            ; yes, scroll page
cmp ax,3d00                            ; f3 key?
je pause_brk                           ; yes, abort program now
cmp ax,0000                            ; break key?
je pause_brk                           ; yes, abort program now
cmp al,03                              ; control-c?
je pause_brk                           ; yes, abort program now
cmp al,11                              ; control-q?  (remapped ^c or break)
je pause_brk                           ; yes, abort program now
cmp al,1b                              ; escape?
je pause_brk                           ; yes, abort program now
cmp al,'C'                             ; c key?
je pause_esc                           ; yes, no more pauses
jne pause_2                            ; no, not a legal key, loop back

pause_esc:
mov b [lines_max],00                   ; escape pressed:  disable pausing
pause_sp:
dosprint msg_unpause                   ; erase the hit-a-key message
ret                                    ; and exit

pause_cr:
mov b [lines_count],01
jmp pause_sp

pause_brk:                             ; control-c hit:
call append_restore
dosprint msg_unpause
dosprint msg_abort
doscall2 4c03                          ; squiff program with errorlevel 03

dec_print_small:                       ; DISPLAY WORD IN AX:
mov dx,0000                            ; fall through ....

dec_print_big:                         ; DISPLAY DOUBLEWORD IN DX:AX
mov w [dp_t1],ax                       ; save the doubleword value
mov w [dp_t2],dx                       ; for later use
mov b [dp_t4],00
mov w [dp_t3],'s' by 'e'
cmp dx,0000
jne dec_print_plural
cmp ax,0001
jne dec_print_plural
mov w [dp_t3],0ffff
dec_print_plural:
mov bx,000a                            ; ten decimal is our divisor
push bx                                ; also our end-of-stack marker
mov cl,00                              ; init digits-between-commas count
dec_print_1:                           ; main decimal division loop
mov dx,0000
mov ax,w [dp_t2]                       ; dx:ax contains the high word as quad
div bx                                 ; divide by ten
mov w [dp_t2],ax                       ; save new high-order word
mov ax,w [dp_t1]                       ; get the old low word
div bx                                 ; and divide by ten
mov w [dp_t1],ax                       ; save new low word
add dx,0030                            ; convert remainder to ascii digit
push dx                                ; and save it on the stack
inc b [dp_t4]
cmp ax,0000                            ; anything left?
jne dec_print_12                       ; if so, continue with divisions
cmp w [dp_t2],0000
je dec_print_15                        ; if not, print out digits
dec_print_12:
test ch,80                             ; supposed to print commas?
jne dec_print_1                        ; if not, loop back for next digit
inc cl                                 ; increment digits-between-commas
cmp cl,03                              ; three digits yet?
jne dec_print_1                        ; if not, loop back for next digit
mov cl,00                              ; yes, zero counter
mov dl,b [country_thou]
mov dh,dl                              ; and push a comma on the stack
push dx
inc b [dp_t4]
jmp dec_print_1                        ; and loop back for next digit
dec_print_15:                          ; done with divisions:
mov ah,02                              ; dos print-character function:
cmp b [dp_min],00                      ; right-justified?
je dec_print_2                         ; if not, print digits now
mov cl,b [dp_min]
sub cl,b [dp_t4]
jbe dec_print_2
mov ch,00
mov dl,20
dec_print_17:
int 21
loop dec_print_17

dec_print_2:                           ; decimal printout loop
pop dx                                 ; get a digit from the stack
cmp dx,000a                            ; hit the end of stack yet?
je dec_print_3                         ; if so, exit decimal print routine
int 21                                 ; otherwise, print the digit
jmp dec_print_2                        ; and loop back for next digit
dec_print_3:
mov b [dp_min],00
mov ax,w [dp_t3]
ret

dp_t1:                                 ; holds low-order word
dw 0000
dp_t2:                                 ; holds high-order word
dw 0000
dp_t3:                                 ; normally holds ascii 'es'
dw 0000
dp_t4:                                 ; count of characters pushed on stack
db 00
dp_min:                                ; minimum number of chars to print
db 00

show_date_format:
dosprint msg_date_format
mov bx,offset msg_date_fmt_0
cmp b [country_date],00
je show_date_format_1
mov bx,offset msg_date_fmt_1
cmp b [country_date],01
je show_date_format_1
mov bx,offset msg_date_fmt_2
show_date_format_1:
mov ah,02
show_date_format_2:
mov dl,b [bx]
inc bx
cmp dl,00
je show_date_format_4
cmp dl,'-'
jne show_date_format_3
mov dl,b [country_dsep]
show_date_format_3:
int 21
jmp show_date_format_2
show_date_format_4:
dosprint msg_crlf
ret

append_restore:                        ; RESTORE APPEND STATE, IF CHANGED:
cmp w [append_hack],0000               ; was append state changed?
je append_rest_x                       ; no, exit
mov bx,w [append_hack]                 ; yes, get original state
mov ax,0b707
int 2f                                 ; set append state
mov w [append_hack],0000               ; clear flag (for no good reason)
append_rest_x:
cmp w [int_15_vec_hi],0000             ; did we hook int 15?
je restore_int15_x                     ; if not, don't restore it.  duh.
mov dx,w [int_15_vec]
mov ds,w [int_15_vec_hi]               ; get original int 15 vector in ds:dx
doscall2 2515                          ; and plug it back in
push cs
pop ds                                 ; get correct data segment back
restore_int15_x:

error_output:                          ; PREPARE TO PRINT AN ERROR MESSAGE:
mov bx,0002                            ; copy standard error handle
mov cx,0001                            ; to standard output handle
doscall 46                             ; dos force-duplicate-handle function
ret

err_tree_ov:                           ; TREE BUFFER OVERFLOW:
call append_restore
dosprint msg_tree_ov                   ; print an error message
doscall2 4c06                          ; and abort with errorlevel 06

syntax:                                ; SYNTAX ERROR:
call append_restore
dosprint msg_syntax                    ; print syntax message
doscall2 4c10                          ; and abort

new_int24:                             ; NEW CRITICAL-ERROR HANDLER:
mov al,03                              ; always fail
iret                                   ; pretty simple, huh?

new_int15:                             ; NEW INT 15 HANDLER:
pushf                                  ; save flags
push es                                ; and .es register on stack
mov es,0040                            ; bios data area is at segment 0040
test b [es:0017],04                    ; is control key pressed?
je new_15_x                            ; if not, exit
cmp ax,4f2e                            ; control-c?
je new_15_fix                          ; if so, change it to control-q
cmp ax,4f46                            ; control-break?
jne new_15_x                           ; if not, exit
and b [es:0096],0fd                    ; disregard previous 0e0 scancode
new_15_fix:                            ;    from control-break sequence
mov al,10                              ; substitute control-q scancode
new_15_x:
pop es                                 ; recover .es register
popf                                   ; and flags from the stack
jmp far [cs:int_15_vec]                ; and resume normal keystroke handling


switches:
db 'PAWSBOJINL2$TXRHDFGMCU1',00

switch_routines:
dw switch_p, switch_a, switch_w, switch_s, switch_b, switch_o
dw switch_j, switch_i, switch_n, switch_l, switch_two, switch_buck
dw switch_t, switch_x, switch_r, switch_h, switch_d, switch_f
dw switch_g, switch_m, switch_c, switch_u, switch_one

fout_switches:
db 'FDPNRXS$ABE&T_QLWZ123',00

fout_routines:
dw fout_fil, fout_dir, fout_pat, fout_nam, fout_roo, fout_ext, fout_buk
dw fout_buk, fout_att, fout_bra, fout_esc, fout_amp, fout_ter, fout_ter
dw fout_quo, fout_let, fout_win, fout_zin, fout_dat, fout_tim, fout_siz

disp_routines:
dw show_peter, name_done, batch_output, formatted_output
dw plain_jane, old_info, bare_naked, sd_bare, lfn_output

num_blank_lines:                       ; to print for each display mode:
db 01,00,00,00,01,02,00,00,02          ; /p /s /b /o /j /i /n /$ /l

msg_syntax:
db 0d,0a
db 'LOCATE.COM   v1.17a   07-12-1996   C. Dye   raster@indirect.com',0d,0a,0a
db 'Syntax:  LOCATE [filespec] [switches]',0d,0a,0a
db '    /H   list only Hidden or system',0d,0a
db '    /X   list only files of type .COM, .EXE, .BAT',0d,0a
db '    /D-  list files only, not Directories',0d,0a
db '    /D+  list Directories only, not files (default is both)',0d,0a
db '    /C   Check attributes',0d,0a
db '    /U   check date stamp',0d,0a
db '    /T   search only current directory and path',0d,0a
db '    /R   no search on Removable or Remote drives',0d,0a
db '    /Fn  find only First n matches',0d,0a
db '    /G   Go to directory',0d,0a
db '    /L   display Win95 long filenames',0d,0a
db '    /N   bare Naked display      /W   Wide display',0d,0a
db '    /S   Summary info only       /P   Peter-style display',0d,0a
db '    /B:"command"  Batch output',0d,0a
db '    /O:"string"   macro Output',0d,0a
db 0a
db 'If you specify both a filespec and switches, you must type a space',0d,0a
db 'before the first switch.  Try /C? /U? /B? or /O? for more info.',0d,0a
db '$'

msg_resize_error:
db 0d,0a,'Error resizing program block!',0d,0a,'$'

msg_alloc_error:
db 0d,0a,'Error allocating tree buffer!',0d,0a,'$'

msg_dos_bad:
db 0d,0a,'This program requires DOS 3.2 or higher!',0d,0a,'$'

msg_buffer_full:
db 0d,0a,'Error:  Filespec too long!',0d,0a,'$'

msg_bad_drv:
db 0d,0a,'Error:  Illegal drive spec!',0d,0a,'$'

msg_dir_wc:
db 0d,0a,'Error:  Wildcards not allowed in directory name!',0d,0a,'$'

msg_wc_fix:
db 0d,0a,'Error:  Illegal use of * wildcard in filespec!',0d,0a,'$'

msg_fz:
db 0d,0a,'Error:  /Fn  -- number cannot be greater than 65535.',0d,0a,'$'

msg_bad_bat:
db 0d,0a
db 'LOCATE /B:"command"   Batch output, with a command',0d,0a
db 'LOCATE /Bn:"command"  with a command and n arguments  (n is 1 to 9)',0d,0a,0a
db 'LOCATE C:*.MS /B3:"ATTRIB"  would produce lines like:',0d,0a,0a
db '   @echo off',0d,0a
db '   ATTRIB C:\CHKLIST.MS %1 %2 %3',0d,0a,0a
db '/B implies an automatic /D-.  Use a /D or /D+ on the command line',0d,0a
db 'to override.',0d,0a
db '$'

msg_bad_format:
db 0d,0a
db 'LOCATE /O:"string"    macro Output; string may include:',0d,0a,0a
db '   &F  fully qualified filename     C:\WINDOWS\WIN.COM',0d,0a
db '   &D  directory name, canonical    C:\WINDOWS',0d,0a
db '   &P  directory name with \        C:\WINDOWS\',0d,0a
db '   &N  filename                     WIN.COM',0d,0a
db '   &R  filename without extension   WIN',0d,0a
db '   &X  extension only               COM',0d,0a
db '   &S  filespec without drive       \WINDOWS\WIN.COM',0d,0a
db '   &L  drive letter                 C:',0d,0a
db '   &A  attributes, standard         +A -S -H -R',0d,0a
db '   &B  attributes in brackets       [A....]',0d,0a
db '   &W  Win95 full LFN               "C:\Directory Name\Long File Name"',0d,0a
db '   &Z  Win95 LFN, filename only     "Long File Name"',0d,0a
db '   &T  terminate line',0d,0a
db '   &&  ampersand    &E  escape    &Q  quote mark',0d,0a
db '   &1  date         &2  time      &3  file size',0d,0a    
db '$'

msg_bad_chk:
db 0d,0a
db 'LOCATE /C...   Check attributes',0d,0a,0a
db '   /CA+  Archive bit must be set',0d,0a
db '   /CA-  Archive bit must be clear',0d,0a
db '   /CS+  System bit must be set',0d,0a
db '   /CH+  Hidden bit must be set',0d,0a
db '   /CA-RH+  Archive clear, Read-only and Hidden set',0d,0a
db '$'

msg_bad_ud:
db 0d,0a
db 'LOCATE /U...   check date stamp',0d,0a,0a
db '   /Udate1         only show items date1 or later',0d,0a
db '   /Udate1,date2   only from date1 through date2',0d,0a
db '   /U,date2        only date2 or earlier',0d,0a
db '   /Udate1!        only date1 exactly; same as /Udate1,date1',0d,0a
db '   /UT             only show items dated Today',0d,0a,0a
db '$'

msg_bat_ovf:
db 0d,0a,'Error:  /B or /O string -- 80 characters max!',0d,0a,'$'

msg_tree_ov:
db 0d,0a,'Error:  Tree buffer overflow!  (Directory structure too complex)',0d,0a,'$'

msg_env_err:
db 0d,0a,'Error:  Illegal switch "'
msg_env_err1:
db '#" in LOCATE variable!',0d,0a,'$'

msg_bat_begin:
db '@echo off',00

msg_bat_arg:
db ' %1',01,00

msg_crlf:
db 0d,0a,'$'

msg_pause:
db 0d,'  <Space> scroll page, <Enter> scroll line, <Esc> abort, <C> continuous :$'

msg_unpause:
db 0d,'                                                                         ',0d,'$'

msg_go_ask:
db 0d,'Go there?  [Y/N/Q/C] $'

msg_abort:
db 0d,0a,'   *** Abort ***',0d,0a,'$'

msg_attrib:
db '[     ]  $'

attr1:
db 'ADSHR'

attr_v:
db 20,10,04,02,01

msg_attrib_2:
db '-A -S -H -R$'

msg_info_1:
db '     $'
msg_info_space  equ  (msg_info_1 + 3)

msg_info_dir:
db '    <Dir>$'

msg_info_ampm:
db ' am  $'

msg_info_open:
db ' ($'

msg_info_kb:
db ' KB)$'

msg_info_mb:
db ' MB)$'

msg_nothing:
db 'No matches found.',00

msg_num_entries:
db ' items found:  ',01,00

msg_num_files:
db ' files',01,00

msg_num_files1:
db ', ',01,00

msg_num_dirs:
db ' directories',01,00

msg_num_dirs1:
db '.',00

msg_hs:
db ' (',01,00

msg_hs1:
db ' H/S)',01,00

msg_maybe_more:
db '   /F$' 
msg_maybe_more1:
db ' was specified; there may be more.',00

msg_maybe_more_2:
db '   /G search ended; there may be more.',00

msg_file_totals:
db '   Total of file sizes:  $'

msg_tree_max:
db 'Maximum value of TREE_END:  $'

star_dot_star:
db '*.*',00

msg_null  equ  star_dot_star + 3

msg_date_format:
db 'Current date format:  $'

msg_date_fmt_0:
db 'MM-DD-YYYY',00

msg_date_fmt_1:
db 'DD-MM-YYYY',00

msg_date_fmt_2:
db 'YYYY-MM-DD',00

var_locate:
db 'LOCATE='

var_path:
db 'PATH='

even 4
end_of_code:
end_code_seg  equ  ((end_of_code + 040f) / 10)


;
;  ERRORLEVEL RETURNS:
;
;     00  File(s) found
;     01  No match found
;     02  Filespec error
;     03  User break may return this value
;     04  Memory allocation error
;     05  Bad DOS
;     06  Tree buffer overflow
;     10  Bad switch or syntax request
;
;
;  VERSION LOG:
;
;  v1.00   06-10-1995
;          Supports /T /X /R /N /D- and /D+
;
;  v1.01   06-12-1995
;          Fixes a bug in /T USE_PATH which prevented proper handling of the
;          root directory when it was current.  Does not attempt to search
;          drive B: on a single-drive system.
;
;  v1.02   06-15-1995
;          Provides a count of matches found.  The decimal-print routine
;          will probably crash if more than 650,000 matches are found.
;          No count messages will be printed if /N was specified.
;
;  v1.03   06-19-1995
;          Better decimal-print routine:  will correctly display up to
;          2^32-1 files.  If only one match is found, will display
;          "1 match" instead of "1 matches".
;
;  v1.04   06-22-1995
;          Hacked to bypass APPEND if installed and active.
;
;  v1.05   07-10-1995
;          Adds /H (list only hidden/system items.)  Final count is now
;          broken down into file and directory counts.
;
;  v1.06   10-21-1995
;          Adds /Fn (find first n files) and /I (displays more info,
;          in a somewhat Peter-like format.)
;  v1.06a  11-05-1995
;          The decimal-print routine now prints commas in large numbers.
;          Space bar allowed (as well as Return) to un-pause output.
;          Unused attributes shown as a period, instead of a space;
;          meanings of attribute letters are listed in the syntax message.
;  v1.06b  11-07-1995
;          Undocumented switch /$ suppresses display of drive letters.
;          Program will abort if TREE_END variable wraps around end of
;          64K buffer.
;  v1.06c  11-13-1995
;          Final file and directory counts include a subcount of hidden or
;          system files/directories.  If /H was specified, the subcounts
;          will be suppressed since they must match the main counts.
;
;  v1.07   11-20-1995
;          /$ behaves more sensibly (only searches one drive, invokes /N
;          automatically.)  If user specifies a filespec of only . or ..
;          these will now be handled correctly.  Parser is now simpler
;          (uses lookup-and-jump table, not monster case switch.)
;
;  v1.08   11-25-1995
;          Adds /B:"command" for automatic batch file creation.  If there
;          are no command line arguments at all, uses a default filespec
;          of *.*
;
;  v1.09   12-08-1995
;          Checks for duplicate drive mappings.  If more than one drive
;          letter is mapped to the same drive, only the lowest will be
;          searched.  /M defeats the drive-mapping check.
;  v1.09a  12-12-1995
;          New switch /S displays summary info (counts) only, not the
;          list of file/directory names.
;  v1.09b  12-14-1995
;          /R now officially skips network and SUBST'ed drives.
;  v1.09c  12-26-1995
;          Makes the pause routine more Peterlike.
;  v1.09d  12-28-1995
;          Allows a keystroke to pause a continuous listing.
;
;  v1.10   01-01-1996
;          Now checks for a LOCATE= environment variable.  All switches are
;          legal in the LOCATE variable except for /B.  Adds /F- which
;          'undoes' any previous /F, setting MAX_COUNT to zero.
;          New switches:  /W - wide Peter display.  /P - long Peter display.
;          /A - Peter display (long or wide).
;          Also fixes a bug in the handling of . and ..
;  v1.10a  01-03-1996
;          Trivial change in the handling of /P.  (Now identical to /A.)
;  v1.10b  01-17-1996
;          Allows use of the Control key to slow down scrolling.  Long live
;          the C64!
;
;  v1.11   02-02-1996
;          Fixes a bug:  LOCATE \FILENAME did not restrict the search to the
;          current drive, as documented; fixed.  Minimum DOS version reduced
;          to 3.2.  Error messages now printed to STDERR, not STDOUT.
;  v1.11a  02-06-1996
;          Long-Peter display now includes attributes.
;  v1.11b  02-09-1996
;          Includes a total of sizes of all files found.
;
;  v1.12   02-16-1996
;          Minor changes:  removes duplicate environment-search code in
;          USE_PATH; trivial changes to syntax display; removes an unused
;          error message.  (Garbo)
;  v1.12a  02-21-1996
;          /B now permits a number of arguments to be printed after the
;          filenames.  LOCATE C: /H /B3:"ATTRIB"  would produce lines like:
;          ATTRIB C:\MSDOS.SYS %1 %2 %3
;  v1.12b  03-06-1996
;          LOCATE . and LOCATE .. now restrict the search to the current
;          drive, as documented.  (LOCATE .\ and so forth did work
;          correctly.)  Basically, the v1.11 bug fix broke the v1.10 bug
;          fix.  Oops.
;
;  v1.13   03-10-1996
;          Adds /O (macro output) and /G (go to directory).
;          /R now has no effect when a drive is specified.  The buffer
;          for /B and /O strings has been increased to 80 bytes from 64.
;          Fixes a minor bug in the handling of /F- /G- and /D- which
;          could prevent the next switch from being handled properly.
;  v1.13a  03-19-1996
;          Checks each drive for validity before starting search on it.
;          This will speed things up a great deal when (1) Netware client
;          software is loaded, and (2) a network cable is not connected.
;  v1.13b  03-20-1996
;          Exactly like v1.13a, except the drive-valid tests are done in
;          a different order (to avoid hitting drives which wouldn't be
;          accessed anyway.)
;
;  v1.14   03-25-1996
;          The /A Peter-style display is now the default.  New switch
;          /J (plain Jane) provides the old, default display format.
;          /P and /A are now allowed to override /W.  Also, more code
;          in DOTS_FIX to handle . and .. after a backslash:  unlikely
;          syntax such as LOCATE C:\DOS\. or LOCATE C:/DOS/.. and so on.
;          Spells 'continuous' correctly.
;
;  v1.15   03-31-1996
;          Major cleanup of the display-modes code.  Combines several
;          byte-sized flag variables into multifunction, bitmapped
;          variables.  Also, fixes nasty handling of /B:"FOO" /B.
;          /X now always implies /D-.
;  v1.15a  04-07-1996
;          Minor change to SHOW_FRACTION routine.  Now it rounds up,
;          so the last digit is more accurate.  (Garbo)
;
;  v1.16   05-21-1996
;          New switch /L displays Win95 long filenames.  New macros &W
;          and &Z display long filenames (corresponding to &F and &N
;          respectively).  Summary count says 'items found' instead of
;          'matches'.  SHOW_FRACTION won't round up past .99.  User
;          may now specify multiple drives; drive specs may be separated
;          from filespec by spaces.  /V is no longer supported.  If the
;          current drive is C: or higher, and the user did not specify a
;          drive, the search starts at drive C: instead of A:.  New switch
;          /C checks file attributes.  'Bytes' message now pluralizes
;          correctly.  /B implies /D- unless the user specifies /D+ or /D
;          on the command line.  (Garbo)
;
;  v1.17   07-04-1996
;          Incorporates Polite Tourist suggestions, courtesy Yves
;          Bellefeuille:  LOCATE now respects Config.sys COUNTRY directives.
;          New switches:  /U checks date stamps; /US overrides COUNTRY,
;          forcing United States output; /2 provides a two-column display;
;          /12 and /24 change time output.  File sizes are somewhat right-
;          justified.  Control-C and Control-Break are trapped.  New macros
;          &1, &2, &3 output date, time, and size, respectively.
;  v1.17a  07-12-1996
;          Forcing 12-hour or 24-hour mode is deferred until command-line
;          parsing is completed.  Accept /U! as a synonym for /UT.  Accept
;          Control-C and Control-Break at /G prompt.
;
